package org.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.services.TestScriptDSLGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalTestScriptDSLParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_INT", "RULE_STRING", "RULE_ID", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'True'", "'False'", "'{}'", "'+'", "'-'", "'*'", "'/'", "'.'", "'import'", "'.*'", "']'", "')'", "'['", "'('", "'='"
    };
    public static final int RULE_STRING=5;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;
    public static final int RULE_ID=6;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=4;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalTestScriptDSLParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalTestScriptDSLParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalTestScriptDSLParser.tokenNames; }
    public String getGrammarFileName() { return "InternalTestScriptDSL.g"; }


    	private TestScriptDSLGrammarAccess grammarAccess;

    	public void setGrammarAccess(TestScriptDSLGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleTestScriptDSL"
    // InternalTestScriptDSL.g:53:1: entryRuleTestScriptDSL : ruleTestScriptDSL EOF ;
    public final void entryRuleTestScriptDSL() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:54:1: ( ruleTestScriptDSL EOF )
            // InternalTestScriptDSL.g:55:1: ruleTestScriptDSL EOF
            {
             before(grammarAccess.getTestScriptDSLRule()); 
            pushFollow(FOLLOW_1);
            ruleTestScriptDSL();

            state._fsp--;

             after(grammarAccess.getTestScriptDSLRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleTestScriptDSL"


    // $ANTLR start "ruleTestScriptDSL"
    // InternalTestScriptDSL.g:62:1: ruleTestScriptDSL : ( ( rule__TestScriptDSL__ElementsAssignment )* ) ;
    public final void ruleTestScriptDSL() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:66:2: ( ( ( rule__TestScriptDSL__ElementsAssignment )* ) )
            // InternalTestScriptDSL.g:67:2: ( ( rule__TestScriptDSL__ElementsAssignment )* )
            {
            // InternalTestScriptDSL.g:67:2: ( ( rule__TestScriptDSL__ElementsAssignment )* )
            // InternalTestScriptDSL.g:68:3: ( rule__TestScriptDSL__ElementsAssignment )*
            {
             before(grammarAccess.getTestScriptDSLAccess().getElementsAssignment()); 
            // InternalTestScriptDSL.g:69:3: ( rule__TestScriptDSL__ElementsAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=RULE_INT && LA1_0<=RULE_ID)||(LA1_0>=11 && LA1_0<=13)||LA1_0==19||LA1_0==24) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalTestScriptDSL.g:69:4: rule__TestScriptDSL__ElementsAssignment
            	    {
            	    pushFollow(FOLLOW_3);
            	    rule__TestScriptDSL__ElementsAssignment();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getTestScriptDSLAccess().getElementsAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleTestScriptDSL"


    // $ANTLR start "entryRuleAbstractElement"
    // InternalTestScriptDSL.g:78:1: entryRuleAbstractElement : ruleAbstractElement EOF ;
    public final void entryRuleAbstractElement() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:79:1: ( ruleAbstractElement EOF )
            // InternalTestScriptDSL.g:80:1: ruleAbstractElement EOF
            {
             before(grammarAccess.getAbstractElementRule()); 
            pushFollow(FOLLOW_1);
            ruleAbstractElement();

            state._fsp--;

             after(grammarAccess.getAbstractElementRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAbstractElement"


    // $ANTLR start "ruleAbstractElement"
    // InternalTestScriptDSL.g:87:1: ruleAbstractElement : ( ( rule__AbstractElement__StmtAssignment ) ) ;
    public final void ruleAbstractElement() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:91:2: ( ( ( rule__AbstractElement__StmtAssignment ) ) )
            // InternalTestScriptDSL.g:92:2: ( ( rule__AbstractElement__StmtAssignment ) )
            {
            // InternalTestScriptDSL.g:92:2: ( ( rule__AbstractElement__StmtAssignment ) )
            // InternalTestScriptDSL.g:93:3: ( rule__AbstractElement__StmtAssignment )
            {
             before(grammarAccess.getAbstractElementAccess().getStmtAssignment()); 
            // InternalTestScriptDSL.g:94:3: ( rule__AbstractElement__StmtAssignment )
            // InternalTestScriptDSL.g:94:4: rule__AbstractElement__StmtAssignment
            {
            pushFollow(FOLLOW_2);
            rule__AbstractElement__StmtAssignment();

            state._fsp--;


            }

             after(grammarAccess.getAbstractElementAccess().getStmtAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAbstractElement"


    // $ANTLR start "entryRuleQualifiedName"
    // InternalTestScriptDSL.g:103:1: entryRuleQualifiedName : ruleQualifiedName EOF ;
    public final void entryRuleQualifiedName() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:104:1: ( ruleQualifiedName EOF )
            // InternalTestScriptDSL.g:105:1: ruleQualifiedName EOF
            {
             before(grammarAccess.getQualifiedNameRule()); 
            pushFollow(FOLLOW_1);
            ruleQualifiedName();

            state._fsp--;

             after(grammarAccess.getQualifiedNameRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedName"


    // $ANTLR start "ruleQualifiedName"
    // InternalTestScriptDSL.g:112:1: ruleQualifiedName : ( ( rule__QualifiedName__Group__0 ) ) ;
    public final void ruleQualifiedName() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:116:2: ( ( ( rule__QualifiedName__Group__0 ) ) )
            // InternalTestScriptDSL.g:117:2: ( ( rule__QualifiedName__Group__0 ) )
            {
            // InternalTestScriptDSL.g:117:2: ( ( rule__QualifiedName__Group__0 ) )
            // InternalTestScriptDSL.g:118:3: ( rule__QualifiedName__Group__0 )
            {
             before(grammarAccess.getQualifiedNameAccess().getGroup()); 
            // InternalTestScriptDSL.g:119:3: ( rule__QualifiedName__Group__0 )
            // InternalTestScriptDSL.g:119:4: rule__QualifiedName__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getQualifiedNameAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedName"


    // $ANTLR start "entryRuleImport"
    // InternalTestScriptDSL.g:128:1: entryRuleImport : ruleImport EOF ;
    public final void entryRuleImport() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:129:1: ( ruleImport EOF )
            // InternalTestScriptDSL.g:130:1: ruleImport EOF
            {
             before(grammarAccess.getImportRule()); 
            pushFollow(FOLLOW_1);
            ruleImport();

            state._fsp--;

             after(grammarAccess.getImportRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalTestScriptDSL.g:137:1: ruleImport : ( ( rule__Import__Group__0 ) ) ;
    public final void ruleImport() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:141:2: ( ( ( rule__Import__Group__0 ) ) )
            // InternalTestScriptDSL.g:142:2: ( ( rule__Import__Group__0 ) )
            {
            // InternalTestScriptDSL.g:142:2: ( ( rule__Import__Group__0 ) )
            // InternalTestScriptDSL.g:143:3: ( rule__Import__Group__0 )
            {
             before(grammarAccess.getImportAccess().getGroup()); 
            // InternalTestScriptDSL.g:144:3: ( rule__Import__Group__0 )
            // InternalTestScriptDSL.g:144:4: rule__Import__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRuleQualifiedNameWithWildcard"
    // InternalTestScriptDSL.g:153:1: entryRuleQualifiedNameWithWildcard : ruleQualifiedNameWithWildcard EOF ;
    public final void entryRuleQualifiedNameWithWildcard() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:154:1: ( ruleQualifiedNameWithWildcard EOF )
            // InternalTestScriptDSL.g:155:1: ruleQualifiedNameWithWildcard EOF
            {
             before(grammarAccess.getQualifiedNameWithWildcardRule()); 
            pushFollow(FOLLOW_1);
            ruleQualifiedNameWithWildcard();

            state._fsp--;

             after(grammarAccess.getQualifiedNameWithWildcardRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedNameWithWildcard"


    // $ANTLR start "ruleQualifiedNameWithWildcard"
    // InternalTestScriptDSL.g:162:1: ruleQualifiedNameWithWildcard : ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) ;
    public final void ruleQualifiedNameWithWildcard() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:166:2: ( ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) )
            // InternalTestScriptDSL.g:167:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            {
            // InternalTestScriptDSL.g:167:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            // InternalTestScriptDSL.g:168:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 
            // InternalTestScriptDSL.g:169:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            // InternalTestScriptDSL.g:169:4: rule__QualifiedNameWithWildcard__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedNameWithWildcard"


    // $ANTLR start "entryRuleQualifiedIndex"
    // InternalTestScriptDSL.g:178:1: entryRuleQualifiedIndex : ruleQualifiedIndex EOF ;
    public final void entryRuleQualifiedIndex() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:179:1: ( ruleQualifiedIndex EOF )
            // InternalTestScriptDSL.g:180:1: ruleQualifiedIndex EOF
            {
             before(grammarAccess.getQualifiedIndexRule()); 
            pushFollow(FOLLOW_1);
            ruleQualifiedIndex();

            state._fsp--;

             after(grammarAccess.getQualifiedIndexRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedIndex"


    // $ANTLR start "ruleQualifiedIndex"
    // InternalTestScriptDSL.g:187:1: ruleQualifiedIndex : ( ( rule__QualifiedIndex__Alternatives ) ) ;
    public final void ruleQualifiedIndex() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:191:2: ( ( ( rule__QualifiedIndex__Alternatives ) ) )
            // InternalTestScriptDSL.g:192:2: ( ( rule__QualifiedIndex__Alternatives ) )
            {
            // InternalTestScriptDSL.g:192:2: ( ( rule__QualifiedIndex__Alternatives ) )
            // InternalTestScriptDSL.g:193:3: ( rule__QualifiedIndex__Alternatives )
            {
             before(grammarAccess.getQualifiedIndexAccess().getAlternatives()); 
            // InternalTestScriptDSL.g:194:3: ( rule__QualifiedIndex__Alternatives )
            // InternalTestScriptDSL.g:194:4: rule__QualifiedIndex__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedIndex__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getQualifiedIndexAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedIndex"


    // $ANTLR start "entryRuleQualifiedValue"
    // InternalTestScriptDSL.g:203:1: entryRuleQualifiedValue : ruleQualifiedValue EOF ;
    public final void entryRuleQualifiedValue() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:204:1: ( ruleQualifiedValue EOF )
            // InternalTestScriptDSL.g:205:1: ruleQualifiedValue EOF
            {
             before(grammarAccess.getQualifiedValueRule()); 
            pushFollow(FOLLOW_1);
            ruleQualifiedValue();

            state._fsp--;

             after(grammarAccess.getQualifiedValueRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedValue"


    // $ANTLR start "ruleQualifiedValue"
    // InternalTestScriptDSL.g:212:1: ruleQualifiedValue : ( ( rule__QualifiedValue__Alternatives ) ) ;
    public final void ruleQualifiedValue() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:216:2: ( ( ( rule__QualifiedValue__Alternatives ) ) )
            // InternalTestScriptDSL.g:217:2: ( ( rule__QualifiedValue__Alternatives ) )
            {
            // InternalTestScriptDSL.g:217:2: ( ( rule__QualifiedValue__Alternatives ) )
            // InternalTestScriptDSL.g:218:3: ( rule__QualifiedValue__Alternatives )
            {
             before(grammarAccess.getQualifiedValueAccess().getAlternatives()); 
            // InternalTestScriptDSL.g:219:3: ( rule__QualifiedValue__Alternatives )
            // InternalTestScriptDSL.g:219:4: rule__QualifiedValue__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedValue__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getQualifiedValueAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedValue"


    // $ANTLR start "entryRuleStmt"
    // InternalTestScriptDSL.g:228:1: entryRuleStmt : ruleStmt EOF ;
    public final void entryRuleStmt() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:229:1: ( ruleStmt EOF )
            // InternalTestScriptDSL.g:230:1: ruleStmt EOF
            {
             before(grammarAccess.getStmtRule()); 
            pushFollow(FOLLOW_1);
            ruleStmt();

            state._fsp--;

             after(grammarAccess.getStmtRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleStmt"


    // $ANTLR start "ruleStmt"
    // InternalTestScriptDSL.g:237:1: ruleStmt : ( ( rule__Stmt__TypeAssignment ) ) ;
    public final void ruleStmt() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:241:2: ( ( ( rule__Stmt__TypeAssignment ) ) )
            // InternalTestScriptDSL.g:242:2: ( ( rule__Stmt__TypeAssignment ) )
            {
            // InternalTestScriptDSL.g:242:2: ( ( rule__Stmt__TypeAssignment ) )
            // InternalTestScriptDSL.g:243:3: ( rule__Stmt__TypeAssignment )
            {
             before(grammarAccess.getStmtAccess().getTypeAssignment()); 
            // InternalTestScriptDSL.g:244:3: ( rule__Stmt__TypeAssignment )
            // InternalTestScriptDSL.g:244:4: rule__Stmt__TypeAssignment
            {
            pushFollow(FOLLOW_2);
            rule__Stmt__TypeAssignment();

            state._fsp--;


            }

             after(grammarAccess.getStmtAccess().getTypeAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleStmt"


    // $ANTLR start "entryRuleExp"
    // InternalTestScriptDSL.g:253:1: entryRuleExp : ruleExp EOF ;
    public final void entryRuleExp() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:254:1: ( ruleExp EOF )
            // InternalTestScriptDSL.g:255:1: ruleExp EOF
            {
             before(grammarAccess.getExpRule()); 
            pushFollow(FOLLOW_1);
            ruleExp();

            state._fsp--;

             after(grammarAccess.getExpRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleExp"


    // $ANTLR start "ruleExp"
    // InternalTestScriptDSL.g:262:1: ruleExp : ( ( rule__Exp__LeftAssignment ) ) ;
    public final void ruleExp() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:266:2: ( ( ( rule__Exp__LeftAssignment ) ) )
            // InternalTestScriptDSL.g:267:2: ( ( rule__Exp__LeftAssignment ) )
            {
            // InternalTestScriptDSL.g:267:2: ( ( rule__Exp__LeftAssignment ) )
            // InternalTestScriptDSL.g:268:3: ( rule__Exp__LeftAssignment )
            {
             before(grammarAccess.getExpAccess().getLeftAssignment()); 
            // InternalTestScriptDSL.g:269:3: ( rule__Exp__LeftAssignment )
            // InternalTestScriptDSL.g:269:4: rule__Exp__LeftAssignment
            {
            pushFollow(FOLLOW_2);
            rule__Exp__LeftAssignment();

            state._fsp--;


            }

             after(grammarAccess.getExpAccess().getLeftAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleExp"


    // $ANTLR start "entryRuleVar"
    // InternalTestScriptDSL.g:278:1: entryRuleVar : ruleVar EOF ;
    public final void entryRuleVar() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:279:1: ( ruleVar EOF )
            // InternalTestScriptDSL.g:280:1: ruleVar EOF
            {
             before(grammarAccess.getVarRule()); 
            pushFollow(FOLLOW_1);
            ruleVar();

            state._fsp--;

             after(grammarAccess.getVarRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleVar"


    // $ANTLR start "ruleVar"
    // InternalTestScriptDSL.g:287:1: ruleVar : ( ( rule__Var__NameAssignment ) ) ;
    public final void ruleVar() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:291:2: ( ( ( rule__Var__NameAssignment ) ) )
            // InternalTestScriptDSL.g:292:2: ( ( rule__Var__NameAssignment ) )
            {
            // InternalTestScriptDSL.g:292:2: ( ( rule__Var__NameAssignment ) )
            // InternalTestScriptDSL.g:293:3: ( rule__Var__NameAssignment )
            {
             before(grammarAccess.getVarAccess().getNameAssignment()); 
            // InternalTestScriptDSL.g:294:3: ( rule__Var__NameAssignment )
            // InternalTestScriptDSL.g:294:4: rule__Var__NameAssignment
            {
            pushFollow(FOLLOW_2);
            rule__Var__NameAssignment();

            state._fsp--;


            }

             after(grammarAccess.getVarAccess().getNameAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleVar"


    // $ANTLR start "entryRuleVal"
    // InternalTestScriptDSL.g:303:1: entryRuleVal : ruleVal EOF ;
    public final void entryRuleVal() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:304:1: ( ruleVal EOF )
            // InternalTestScriptDSL.g:305:1: ruleVal EOF
            {
             before(grammarAccess.getValRule()); 
            pushFollow(FOLLOW_1);
            ruleVal();

            state._fsp--;

             after(grammarAccess.getValRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleVal"


    // $ANTLR start "ruleVal"
    // InternalTestScriptDSL.g:312:1: ruleVal : ( ( rule__Val__NameAssignment ) ) ;
    public final void ruleVal() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:316:2: ( ( ( rule__Val__NameAssignment ) ) )
            // InternalTestScriptDSL.g:317:2: ( ( rule__Val__NameAssignment ) )
            {
            // InternalTestScriptDSL.g:317:2: ( ( rule__Val__NameAssignment ) )
            // InternalTestScriptDSL.g:318:3: ( rule__Val__NameAssignment )
            {
             before(grammarAccess.getValAccess().getNameAssignment()); 
            // InternalTestScriptDSL.g:319:3: ( rule__Val__NameAssignment )
            // InternalTestScriptDSL.g:319:4: rule__Val__NameAssignment
            {
            pushFollow(FOLLOW_2);
            rule__Val__NameAssignment();

            state._fsp--;


            }

             after(grammarAccess.getValAccess().getNameAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleVal"


    // $ANTLR start "entryRuleDot"
    // InternalTestScriptDSL.g:328:1: entryRuleDot : ruleDot EOF ;
    public final void entryRuleDot() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:329:1: ( ruleDot EOF )
            // InternalTestScriptDSL.g:330:1: ruleDot EOF
            {
             before(grammarAccess.getDotRule()); 
            pushFollow(FOLLOW_1);
            ruleDot();

            state._fsp--;

             after(grammarAccess.getDotRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleDot"


    // $ANTLR start "ruleDot"
    // InternalTestScriptDSL.g:337:1: ruleDot : ( ( rule__Dot__Group__0 ) ) ;
    public final void ruleDot() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:341:2: ( ( ( rule__Dot__Group__0 ) ) )
            // InternalTestScriptDSL.g:342:2: ( ( rule__Dot__Group__0 ) )
            {
            // InternalTestScriptDSL.g:342:2: ( ( rule__Dot__Group__0 ) )
            // InternalTestScriptDSL.g:343:3: ( rule__Dot__Group__0 )
            {
             before(grammarAccess.getDotAccess().getGroup()); 
            // InternalTestScriptDSL.g:344:3: ( rule__Dot__Group__0 )
            // InternalTestScriptDSL.g:344:4: rule__Dot__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Dot__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getDotAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleDot"


    // $ANTLR start "entryRuleArray"
    // InternalTestScriptDSL.g:353:1: entryRuleArray : ruleArray EOF ;
    public final void entryRuleArray() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:354:1: ( ruleArray EOF )
            // InternalTestScriptDSL.g:355:1: ruleArray EOF
            {
             before(grammarAccess.getArrayRule()); 
            pushFollow(FOLLOW_1);
            ruleArray();

            state._fsp--;

             after(grammarAccess.getArrayRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleArray"


    // $ANTLR start "ruleArray"
    // InternalTestScriptDSL.g:362:1: ruleArray : ( ( rule__Array__Group__0 ) ) ;
    public final void ruleArray() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:366:2: ( ( ( rule__Array__Group__0 ) ) )
            // InternalTestScriptDSL.g:367:2: ( ( rule__Array__Group__0 ) )
            {
            // InternalTestScriptDSL.g:367:2: ( ( rule__Array__Group__0 ) )
            // InternalTestScriptDSL.g:368:3: ( rule__Array__Group__0 )
            {
             before(grammarAccess.getArrayAccess().getGroup()); 
            // InternalTestScriptDSL.g:369:3: ( rule__Array__Group__0 )
            // InternalTestScriptDSL.g:369:4: rule__Array__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Array__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getArrayAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleArray"


    // $ANTLR start "entryRulePrimary"
    // InternalTestScriptDSL.g:378:1: entryRulePrimary : rulePrimary EOF ;
    public final void entryRulePrimary() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:379:1: ( rulePrimary EOF )
            // InternalTestScriptDSL.g:380:1: rulePrimary EOF
            {
             before(grammarAccess.getPrimaryRule()); 
            pushFollow(FOLLOW_1);
            rulePrimary();

            state._fsp--;

             after(grammarAccess.getPrimaryRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePrimary"


    // $ANTLR start "rulePrimary"
    // InternalTestScriptDSL.g:387:1: rulePrimary : ( ( rule__Primary__Alternatives ) ) ;
    public final void rulePrimary() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:391:2: ( ( ( rule__Primary__Alternatives ) ) )
            // InternalTestScriptDSL.g:392:2: ( ( rule__Primary__Alternatives ) )
            {
            // InternalTestScriptDSL.g:392:2: ( ( rule__Primary__Alternatives ) )
            // InternalTestScriptDSL.g:393:3: ( rule__Primary__Alternatives )
            {
             before(grammarAccess.getPrimaryAccess().getAlternatives()); 
            // InternalTestScriptDSL.g:394:3: ( rule__Primary__Alternatives )
            // InternalTestScriptDSL.g:394:4: rule__Primary__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Primary__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getPrimaryAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePrimary"


    // $ANTLR start "entryRuleEqual"
    // InternalTestScriptDSL.g:403:1: entryRuleEqual : ruleEqual EOF ;
    public final void entryRuleEqual() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:404:1: ( ruleEqual EOF )
            // InternalTestScriptDSL.g:405:1: ruleEqual EOF
            {
             before(grammarAccess.getEqualRule()); 
            pushFollow(FOLLOW_1);
            ruleEqual();

            state._fsp--;

             after(grammarAccess.getEqualRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleEqual"


    // $ANTLR start "ruleEqual"
    // InternalTestScriptDSL.g:412:1: ruleEqual : ( ( rule__Equal__Group__0 ) ) ;
    public final void ruleEqual() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:416:2: ( ( ( rule__Equal__Group__0 ) ) )
            // InternalTestScriptDSL.g:417:2: ( ( rule__Equal__Group__0 ) )
            {
            // InternalTestScriptDSL.g:417:2: ( ( rule__Equal__Group__0 ) )
            // InternalTestScriptDSL.g:418:3: ( rule__Equal__Group__0 )
            {
             before(grammarAccess.getEqualAccess().getGroup()); 
            // InternalTestScriptDSL.g:419:3: ( rule__Equal__Group__0 )
            // InternalTestScriptDSL.g:419:4: rule__Equal__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Equal__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getEqualAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleEqual"


    // $ANTLR start "entryRuleAddAndSub"
    // InternalTestScriptDSL.g:428:1: entryRuleAddAndSub : ruleAddAndSub EOF ;
    public final void entryRuleAddAndSub() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:429:1: ( ruleAddAndSub EOF )
            // InternalTestScriptDSL.g:430:1: ruleAddAndSub EOF
            {
             before(grammarAccess.getAddAndSubRule()); 
            pushFollow(FOLLOW_1);
            ruleAddAndSub();

            state._fsp--;

             after(grammarAccess.getAddAndSubRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAddAndSub"


    // $ANTLR start "ruleAddAndSub"
    // InternalTestScriptDSL.g:437:1: ruleAddAndSub : ( ( rule__AddAndSub__Group__0 ) ) ;
    public final void ruleAddAndSub() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:441:2: ( ( ( rule__AddAndSub__Group__0 ) ) )
            // InternalTestScriptDSL.g:442:2: ( ( rule__AddAndSub__Group__0 ) )
            {
            // InternalTestScriptDSL.g:442:2: ( ( rule__AddAndSub__Group__0 ) )
            // InternalTestScriptDSL.g:443:3: ( rule__AddAndSub__Group__0 )
            {
             before(grammarAccess.getAddAndSubAccess().getGroup()); 
            // InternalTestScriptDSL.g:444:3: ( rule__AddAndSub__Group__0 )
            // InternalTestScriptDSL.g:444:4: rule__AddAndSub__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__AddAndSub__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAddAndSubAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAddAndSub"


    // $ANTLR start "entryRuleMulAndDiv"
    // InternalTestScriptDSL.g:453:1: entryRuleMulAndDiv : ruleMulAndDiv EOF ;
    public final void entryRuleMulAndDiv() throws RecognitionException {
        try {
            // InternalTestScriptDSL.g:454:1: ( ruleMulAndDiv EOF )
            // InternalTestScriptDSL.g:455:1: ruleMulAndDiv EOF
            {
             before(grammarAccess.getMulAndDivRule()); 
            pushFollow(FOLLOW_1);
            ruleMulAndDiv();

            state._fsp--;

             after(grammarAccess.getMulAndDivRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleMulAndDiv"


    // $ANTLR start "ruleMulAndDiv"
    // InternalTestScriptDSL.g:462:1: ruleMulAndDiv : ( ( rule__MulAndDiv__Group__0 ) ) ;
    public final void ruleMulAndDiv() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:466:2: ( ( ( rule__MulAndDiv__Group__0 ) ) )
            // InternalTestScriptDSL.g:467:2: ( ( rule__MulAndDiv__Group__0 ) )
            {
            // InternalTestScriptDSL.g:467:2: ( ( rule__MulAndDiv__Group__0 ) )
            // InternalTestScriptDSL.g:468:3: ( rule__MulAndDiv__Group__0 )
            {
             before(grammarAccess.getMulAndDivAccess().getGroup()); 
            // InternalTestScriptDSL.g:469:3: ( rule__MulAndDiv__Group__0 )
            // InternalTestScriptDSL.g:469:4: rule__MulAndDiv__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__MulAndDiv__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getMulAndDivAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleMulAndDiv"


    // $ANTLR start "rule__QualifiedIndex__Alternatives"
    // InternalTestScriptDSL.g:477:1: rule__QualifiedIndex__Alternatives : ( ( RULE_INT ) | ( RULE_STRING ) );
    public final void rule__QualifiedIndex__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:481:1: ( ( RULE_INT ) | ( RULE_STRING ) )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==RULE_INT) ) {
                alt2=1;
            }
            else if ( (LA2_0==RULE_STRING) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // InternalTestScriptDSL.g:482:2: ( RULE_INT )
                    {
                    // InternalTestScriptDSL.g:482:2: ( RULE_INT )
                    // InternalTestScriptDSL.g:483:3: RULE_INT
                    {
                     before(grammarAccess.getQualifiedIndexAccess().getINTTerminalRuleCall_0()); 
                    match(input,RULE_INT,FOLLOW_2); 
                     after(grammarAccess.getQualifiedIndexAccess().getINTTerminalRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:488:2: ( RULE_STRING )
                    {
                    // InternalTestScriptDSL.g:488:2: ( RULE_STRING )
                    // InternalTestScriptDSL.g:489:3: RULE_STRING
                    {
                     before(grammarAccess.getQualifiedIndexAccess().getSTRINGTerminalRuleCall_1()); 
                    match(input,RULE_STRING,FOLLOW_2); 
                     after(grammarAccess.getQualifiedIndexAccess().getSTRINGTerminalRuleCall_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedIndex__Alternatives"


    // $ANTLR start "rule__QualifiedValue__Alternatives"
    // InternalTestScriptDSL.g:498:1: rule__QualifiedValue__Alternatives : ( ( RULE_STRING ) | ( 'True' ) | ( 'False' ) | ( RULE_INT ) | ( '{}' ) );
    public final void rule__QualifiedValue__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:502:1: ( ( RULE_STRING ) | ( 'True' ) | ( 'False' ) | ( RULE_INT ) | ( '{}' ) )
            int alt3=5;
            switch ( input.LA(1) ) {
            case RULE_STRING:
                {
                alt3=1;
                }
                break;
            case 11:
                {
                alt3=2;
                }
                break;
            case 12:
                {
                alt3=3;
                }
                break;
            case RULE_INT:
                {
                alt3=4;
                }
                break;
            case 13:
                {
                alt3=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }

            switch (alt3) {
                case 1 :
                    // InternalTestScriptDSL.g:503:2: ( RULE_STRING )
                    {
                    // InternalTestScriptDSL.g:503:2: ( RULE_STRING )
                    // InternalTestScriptDSL.g:504:3: RULE_STRING
                    {
                     before(grammarAccess.getQualifiedValueAccess().getSTRINGTerminalRuleCall_0()); 
                    match(input,RULE_STRING,FOLLOW_2); 
                     after(grammarAccess.getQualifiedValueAccess().getSTRINGTerminalRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:509:2: ( 'True' )
                    {
                    // InternalTestScriptDSL.g:509:2: ( 'True' )
                    // InternalTestScriptDSL.g:510:3: 'True'
                    {
                     before(grammarAccess.getQualifiedValueAccess().getTrueKeyword_1()); 
                    match(input,11,FOLLOW_2); 
                     after(grammarAccess.getQualifiedValueAccess().getTrueKeyword_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalTestScriptDSL.g:515:2: ( 'False' )
                    {
                    // InternalTestScriptDSL.g:515:2: ( 'False' )
                    // InternalTestScriptDSL.g:516:3: 'False'
                    {
                     before(grammarAccess.getQualifiedValueAccess().getFalseKeyword_2()); 
                    match(input,12,FOLLOW_2); 
                     after(grammarAccess.getQualifiedValueAccess().getFalseKeyword_2()); 

                    }


                    }
                    break;
                case 4 :
                    // InternalTestScriptDSL.g:521:2: ( RULE_INT )
                    {
                    // InternalTestScriptDSL.g:521:2: ( RULE_INT )
                    // InternalTestScriptDSL.g:522:3: RULE_INT
                    {
                     before(grammarAccess.getQualifiedValueAccess().getINTTerminalRuleCall_3()); 
                    match(input,RULE_INT,FOLLOW_2); 
                     after(grammarAccess.getQualifiedValueAccess().getINTTerminalRuleCall_3()); 

                    }


                    }
                    break;
                case 5 :
                    // InternalTestScriptDSL.g:527:2: ( '{}' )
                    {
                    // InternalTestScriptDSL.g:527:2: ( '{}' )
                    // InternalTestScriptDSL.g:528:3: '{}'
                    {
                     before(grammarAccess.getQualifiedValueAccess().getLeftCurlyBracketRightCurlyBracketKeyword_4()); 
                    match(input,13,FOLLOW_2); 
                     after(grammarAccess.getQualifiedValueAccess().getLeftCurlyBracketRightCurlyBracketKeyword_4()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedValue__Alternatives"


    // $ANTLR start "rule__Stmt__TypeAlternatives_0"
    // InternalTestScriptDSL.g:537:1: rule__Stmt__TypeAlternatives_0 : ( ( ruleExp ) | ( ruleImport ) );
    public final void rule__Stmt__TypeAlternatives_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:541:1: ( ( ruleExp ) | ( ruleImport ) )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( ((LA4_0>=RULE_INT && LA4_0<=RULE_ID)||(LA4_0>=11 && LA4_0<=13)||LA4_0==24) ) {
                alt4=1;
            }
            else if ( (LA4_0==19) ) {
                alt4=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // InternalTestScriptDSL.g:542:2: ( ruleExp )
                    {
                    // InternalTestScriptDSL.g:542:2: ( ruleExp )
                    // InternalTestScriptDSL.g:543:3: ruleExp
                    {
                     before(grammarAccess.getStmtAccess().getTypeExpParserRuleCall_0_0()); 
                    pushFollow(FOLLOW_2);
                    ruleExp();

                    state._fsp--;

                     after(grammarAccess.getStmtAccess().getTypeExpParserRuleCall_0_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:548:2: ( ruleImport )
                    {
                    // InternalTestScriptDSL.g:548:2: ( ruleImport )
                    // InternalTestScriptDSL.g:549:3: ruleImport
                    {
                     before(grammarAccess.getStmtAccess().getTypeImportParserRuleCall_0_1()); 
                    pushFollow(FOLLOW_2);
                    ruleImport();

                    state._fsp--;

                     after(grammarAccess.getStmtAccess().getTypeImportParserRuleCall_0_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Stmt__TypeAlternatives_0"


    // $ANTLR start "rule__Primary__Alternatives"
    // InternalTestScriptDSL.g:558:1: rule__Primary__Alternatives : ( ( ( rule__Primary__Group_0__0 ) ) | ( ( rule__Primary__LeftAssignment_1 ) ) | ( ( rule__Primary__LeftAssignment_2 ) ) );
    public final void rule__Primary__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:562:1: ( ( ( rule__Primary__Group_0__0 ) ) | ( ( rule__Primary__LeftAssignment_1 ) ) | ( ( rule__Primary__LeftAssignment_2 ) ) )
            int alt5=3;
            switch ( input.LA(1) ) {
            case 24:
                {
                alt5=1;
                }
                break;
            case RULE_ID:
                {
                alt5=2;
                }
                break;
            case RULE_INT:
            case RULE_STRING:
            case 11:
            case 12:
            case 13:
                {
                alt5=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // InternalTestScriptDSL.g:563:2: ( ( rule__Primary__Group_0__0 ) )
                    {
                    // InternalTestScriptDSL.g:563:2: ( ( rule__Primary__Group_0__0 ) )
                    // InternalTestScriptDSL.g:564:3: ( rule__Primary__Group_0__0 )
                    {
                     before(grammarAccess.getPrimaryAccess().getGroup_0()); 
                    // InternalTestScriptDSL.g:565:3: ( rule__Primary__Group_0__0 )
                    // InternalTestScriptDSL.g:565:4: rule__Primary__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Primary__Group_0__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getPrimaryAccess().getGroup_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:569:2: ( ( rule__Primary__LeftAssignment_1 ) )
                    {
                    // InternalTestScriptDSL.g:569:2: ( ( rule__Primary__LeftAssignment_1 ) )
                    // InternalTestScriptDSL.g:570:3: ( rule__Primary__LeftAssignment_1 )
                    {
                     before(grammarAccess.getPrimaryAccess().getLeftAssignment_1()); 
                    // InternalTestScriptDSL.g:571:3: ( rule__Primary__LeftAssignment_1 )
                    // InternalTestScriptDSL.g:571:4: rule__Primary__LeftAssignment_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__Primary__LeftAssignment_1();

                    state._fsp--;


                    }

                     after(grammarAccess.getPrimaryAccess().getLeftAssignment_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalTestScriptDSL.g:575:2: ( ( rule__Primary__LeftAssignment_2 ) )
                    {
                    // InternalTestScriptDSL.g:575:2: ( ( rule__Primary__LeftAssignment_2 ) )
                    // InternalTestScriptDSL.g:576:3: ( rule__Primary__LeftAssignment_2 )
                    {
                     before(grammarAccess.getPrimaryAccess().getLeftAssignment_2()); 
                    // InternalTestScriptDSL.g:577:3: ( rule__Primary__LeftAssignment_2 )
                    // InternalTestScriptDSL.g:577:4: rule__Primary__LeftAssignment_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__Primary__LeftAssignment_2();

                    state._fsp--;


                    }

                     after(grammarAccess.getPrimaryAccess().getLeftAssignment_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__Alternatives"


    // $ANTLR start "rule__AddAndSub__OpAlternatives_1_1_0"
    // InternalTestScriptDSL.g:585:1: rule__AddAndSub__OpAlternatives_1_1_0 : ( ( '+' ) | ( '-' ) );
    public final void rule__AddAndSub__OpAlternatives_1_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:589:1: ( ( '+' ) | ( '-' ) )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==14) ) {
                alt6=1;
            }
            else if ( (LA6_0==15) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // InternalTestScriptDSL.g:590:2: ( '+' )
                    {
                    // InternalTestScriptDSL.g:590:2: ( '+' )
                    // InternalTestScriptDSL.g:591:3: '+'
                    {
                     before(grammarAccess.getAddAndSubAccess().getOpPlusSignKeyword_1_1_0_0()); 
                    match(input,14,FOLLOW_2); 
                     after(grammarAccess.getAddAndSubAccess().getOpPlusSignKeyword_1_1_0_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:596:2: ( '-' )
                    {
                    // InternalTestScriptDSL.g:596:2: ( '-' )
                    // InternalTestScriptDSL.g:597:3: '-'
                    {
                     before(grammarAccess.getAddAndSubAccess().getOpHyphenMinusKeyword_1_1_0_1()); 
                    match(input,15,FOLLOW_2); 
                     after(grammarAccess.getAddAndSubAccess().getOpHyphenMinusKeyword_1_1_0_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__OpAlternatives_1_1_0"


    // $ANTLR start "rule__MulAndDiv__OpAlternatives_1_1_0"
    // InternalTestScriptDSL.g:606:1: rule__MulAndDiv__OpAlternatives_1_1_0 : ( ( '*' ) | ( '/' ) );
    public final void rule__MulAndDiv__OpAlternatives_1_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:610:1: ( ( '*' ) | ( '/' ) )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==16) ) {
                alt7=1;
            }
            else if ( (LA7_0==17) ) {
                alt7=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // InternalTestScriptDSL.g:611:2: ( '*' )
                    {
                    // InternalTestScriptDSL.g:611:2: ( '*' )
                    // InternalTestScriptDSL.g:612:3: '*'
                    {
                     before(grammarAccess.getMulAndDivAccess().getOpAsteriskKeyword_1_1_0_0()); 
                    match(input,16,FOLLOW_2); 
                     after(grammarAccess.getMulAndDivAccess().getOpAsteriskKeyword_1_1_0_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:617:2: ( '/' )
                    {
                    // InternalTestScriptDSL.g:617:2: ( '/' )
                    // InternalTestScriptDSL.g:618:3: '/'
                    {
                     before(grammarAccess.getMulAndDivAccess().getOpSolidusKeyword_1_1_0_1()); 
                    match(input,17,FOLLOW_2); 
                     after(grammarAccess.getMulAndDivAccess().getOpSolidusKeyword_1_1_0_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__OpAlternatives_1_1_0"


    // $ANTLR start "rule__QualifiedName__Group__0"
    // InternalTestScriptDSL.g:627:1: rule__QualifiedName__Group__0 : rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 ;
    public final void rule__QualifiedName__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:631:1: ( rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 )
            // InternalTestScriptDSL.g:632:2: rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__QualifiedName__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0"


    // $ANTLR start "rule__QualifiedName__Group__0__Impl"
    // InternalTestScriptDSL.g:639:1: rule__QualifiedName__Group__0__Impl : ( RULE_ID ) ;
    public final void rule__QualifiedName__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:643:1: ( ( RULE_ID ) )
            // InternalTestScriptDSL.g:644:1: ( RULE_ID )
            {
            // InternalTestScriptDSL.g:644:1: ( RULE_ID )
            // InternalTestScriptDSL.g:645:2: RULE_ID
            {
             before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group__1"
    // InternalTestScriptDSL.g:654:1: rule__QualifiedName__Group__1 : rule__QualifiedName__Group__1__Impl ;
    public final void rule__QualifiedName__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:658:1: ( rule__QualifiedName__Group__1__Impl )
            // InternalTestScriptDSL.g:659:2: rule__QualifiedName__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1"


    // $ANTLR start "rule__QualifiedName__Group__1__Impl"
    // InternalTestScriptDSL.g:665:1: rule__QualifiedName__Group__1__Impl : ( ( rule__QualifiedName__Group_1__0 )* ) ;
    public final void rule__QualifiedName__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:669:1: ( ( ( rule__QualifiedName__Group_1__0 )* ) )
            // InternalTestScriptDSL.g:670:1: ( ( rule__QualifiedName__Group_1__0 )* )
            {
            // InternalTestScriptDSL.g:670:1: ( ( rule__QualifiedName__Group_1__0 )* )
            // InternalTestScriptDSL.g:671:2: ( rule__QualifiedName__Group_1__0 )*
            {
             before(grammarAccess.getQualifiedNameAccess().getGroup_1()); 
            // InternalTestScriptDSL.g:672:2: ( rule__QualifiedName__Group_1__0 )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==18) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // InternalTestScriptDSL.g:672:3: rule__QualifiedName__Group_1__0
            	    {
            	    pushFollow(FOLLOW_5);
            	    rule__QualifiedName__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);

             after(grammarAccess.getQualifiedNameAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__0"
    // InternalTestScriptDSL.g:681:1: rule__QualifiedName__Group_1__0 : rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 ;
    public final void rule__QualifiedName__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:685:1: ( rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 )
            // InternalTestScriptDSL.g:686:2: rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1
            {
            pushFollow(FOLLOW_6);
            rule__QualifiedName__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0"


    // $ANTLR start "rule__QualifiedName__Group_1__0__Impl"
    // InternalTestScriptDSL.g:693:1: rule__QualifiedName__Group_1__0__Impl : ( '.' ) ;
    public final void rule__QualifiedName__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:697:1: ( ( '.' ) )
            // InternalTestScriptDSL.g:698:1: ( '.' )
            {
            // InternalTestScriptDSL.g:698:1: ( '.' )
            // InternalTestScriptDSL.g:699:2: '.'
            {
             before(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__1"
    // InternalTestScriptDSL.g:708:1: rule__QualifiedName__Group_1__1 : rule__QualifiedName__Group_1__1__Impl ;
    public final void rule__QualifiedName__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:712:1: ( rule__QualifiedName__Group_1__1__Impl )
            // InternalTestScriptDSL.g:713:2: rule__QualifiedName__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1"


    // $ANTLR start "rule__QualifiedName__Group_1__1__Impl"
    // InternalTestScriptDSL.g:719:1: rule__QualifiedName__Group_1__1__Impl : ( RULE_ID ) ;
    public final void rule__QualifiedName__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:723:1: ( ( RULE_ID ) )
            // InternalTestScriptDSL.g:724:1: ( RULE_ID )
            {
            // InternalTestScriptDSL.g:724:1: ( RULE_ID )
            // InternalTestScriptDSL.g:725:2: RULE_ID
            {
             before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1__Impl"


    // $ANTLR start "rule__Import__Group__0"
    // InternalTestScriptDSL.g:735:1: rule__Import__Group__0 : rule__Import__Group__0__Impl rule__Import__Group__1 ;
    public final void rule__Import__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:739:1: ( rule__Import__Group__0__Impl rule__Import__Group__1 )
            // InternalTestScriptDSL.g:740:2: rule__Import__Group__0__Impl rule__Import__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Import__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Import__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0"


    // $ANTLR start "rule__Import__Group__0__Impl"
    // InternalTestScriptDSL.g:747:1: rule__Import__Group__0__Impl : ( 'import' ) ;
    public final void rule__Import__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:751:1: ( ( 'import' ) )
            // InternalTestScriptDSL.g:752:1: ( 'import' )
            {
            // InternalTestScriptDSL.g:752:1: ( 'import' )
            // InternalTestScriptDSL.g:753:2: 'import'
            {
             before(grammarAccess.getImportAccess().getImportKeyword_0()); 
            match(input,19,FOLLOW_2); 
             after(grammarAccess.getImportAccess().getImportKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0__Impl"


    // $ANTLR start "rule__Import__Group__1"
    // InternalTestScriptDSL.g:762:1: rule__Import__Group__1 : rule__Import__Group__1__Impl ;
    public final void rule__Import__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:766:1: ( rule__Import__Group__1__Impl )
            // InternalTestScriptDSL.g:767:2: rule__Import__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1"


    // $ANTLR start "rule__Import__Group__1__Impl"
    // InternalTestScriptDSL.g:773:1: rule__Import__Group__1__Impl : ( ( rule__Import__ImportedNamespaceAssignment_1 ) ) ;
    public final void rule__Import__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:777:1: ( ( ( rule__Import__ImportedNamespaceAssignment_1 ) ) )
            // InternalTestScriptDSL.g:778:1: ( ( rule__Import__ImportedNamespaceAssignment_1 ) )
            {
            // InternalTestScriptDSL.g:778:1: ( ( rule__Import__ImportedNamespaceAssignment_1 ) )
            // InternalTestScriptDSL.g:779:2: ( rule__Import__ImportedNamespaceAssignment_1 )
            {
             before(grammarAccess.getImportAccess().getImportedNamespaceAssignment_1()); 
            // InternalTestScriptDSL.g:780:2: ( rule__Import__ImportedNamespaceAssignment_1 )
            // InternalTestScriptDSL.g:780:3: rule__Import__ImportedNamespaceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Import__ImportedNamespaceAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getImportedNamespaceAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0"
    // InternalTestScriptDSL.g:789:1: rule__QualifiedNameWithWildcard__Group__0 : rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 ;
    public final void rule__QualifiedNameWithWildcard__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:793:1: ( rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 )
            // InternalTestScriptDSL.g:794:2: rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1
            {
            pushFollow(FOLLOW_7);
            rule__QualifiedNameWithWildcard__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0__Impl"
    // InternalTestScriptDSL.g:801:1: rule__QualifiedNameWithWildcard__Group__0__Impl : ( ruleQualifiedName ) ;
    public final void rule__QualifiedNameWithWildcard__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:805:1: ( ( ruleQualifiedName ) )
            // InternalTestScriptDSL.g:806:1: ( ruleQualifiedName )
            {
            // InternalTestScriptDSL.g:806:1: ( ruleQualifiedName )
            // InternalTestScriptDSL.g:807:2: ruleQualifiedName
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1"
    // InternalTestScriptDSL.g:816:1: rule__QualifiedNameWithWildcard__Group__1 : rule__QualifiedNameWithWildcard__Group__1__Impl ;
    public final void rule__QualifiedNameWithWildcard__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:820:1: ( rule__QualifiedNameWithWildcard__Group__1__Impl )
            // InternalTestScriptDSL.g:821:2: rule__QualifiedNameWithWildcard__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1__Impl"
    // InternalTestScriptDSL.g:827:1: rule__QualifiedNameWithWildcard__Group__1__Impl : ( ( '.*' )? ) ;
    public final void rule__QualifiedNameWithWildcard__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:831:1: ( ( ( '.*' )? ) )
            // InternalTestScriptDSL.g:832:1: ( ( '.*' )? )
            {
            // InternalTestScriptDSL.g:832:1: ( ( '.*' )? )
            // InternalTestScriptDSL.g:833:2: ( '.*' )?
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopAsteriskKeyword_1()); 
            // InternalTestScriptDSL.g:834:2: ( '.*' )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==20) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // InternalTestScriptDSL.g:834:3: '.*'
                    {
                    match(input,20,FOLLOW_2); 

                    }
                    break;

            }

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopAsteriskKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1__Impl"


    // $ANTLR start "rule__Dot__Group__0"
    // InternalTestScriptDSL.g:843:1: rule__Dot__Group__0 : rule__Dot__Group__0__Impl rule__Dot__Group__1 ;
    public final void rule__Dot__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:847:1: ( rule__Dot__Group__0__Impl rule__Dot__Group__1 )
            // InternalTestScriptDSL.g:848:2: rule__Dot__Group__0__Impl rule__Dot__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__Dot__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Dot__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group__0"


    // $ANTLR start "rule__Dot__Group__0__Impl"
    // InternalTestScriptDSL.g:855:1: rule__Dot__Group__0__Impl : ( ( rule__Dot__LeftAssignment_0 ) ) ;
    public final void rule__Dot__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:859:1: ( ( ( rule__Dot__LeftAssignment_0 ) ) )
            // InternalTestScriptDSL.g:860:1: ( ( rule__Dot__LeftAssignment_0 ) )
            {
            // InternalTestScriptDSL.g:860:1: ( ( rule__Dot__LeftAssignment_0 ) )
            // InternalTestScriptDSL.g:861:2: ( rule__Dot__LeftAssignment_0 )
            {
             before(grammarAccess.getDotAccess().getLeftAssignment_0()); 
            // InternalTestScriptDSL.g:862:2: ( rule__Dot__LeftAssignment_0 )
            // InternalTestScriptDSL.g:862:3: rule__Dot__LeftAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Dot__LeftAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getDotAccess().getLeftAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group__0__Impl"


    // $ANTLR start "rule__Dot__Group__1"
    // InternalTestScriptDSL.g:870:1: rule__Dot__Group__1 : rule__Dot__Group__1__Impl ;
    public final void rule__Dot__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:874:1: ( rule__Dot__Group__1__Impl )
            // InternalTestScriptDSL.g:875:2: rule__Dot__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Dot__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group__1"


    // $ANTLR start "rule__Dot__Group__1__Impl"
    // InternalTestScriptDSL.g:881:1: rule__Dot__Group__1__Impl : ( ( rule__Dot__Group_1__0 )* ) ;
    public final void rule__Dot__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:885:1: ( ( ( rule__Dot__Group_1__0 )* ) )
            // InternalTestScriptDSL.g:886:1: ( ( rule__Dot__Group_1__0 )* )
            {
            // InternalTestScriptDSL.g:886:1: ( ( rule__Dot__Group_1__0 )* )
            // InternalTestScriptDSL.g:887:2: ( rule__Dot__Group_1__0 )*
            {
             before(grammarAccess.getDotAccess().getGroup_1()); 
            // InternalTestScriptDSL.g:888:2: ( rule__Dot__Group_1__0 )*
            loop10:
            do {
                int alt10=2;
                int LA10_0 = input.LA(1);

                if ( (LA10_0==18) ) {
                    alt10=1;
                }


                switch (alt10) {
            	case 1 :
            	    // InternalTestScriptDSL.g:888:3: rule__Dot__Group_1__0
            	    {
            	    pushFollow(FOLLOW_5);
            	    rule__Dot__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);

             after(grammarAccess.getDotAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group__1__Impl"


    // $ANTLR start "rule__Dot__Group_1__0"
    // InternalTestScriptDSL.g:897:1: rule__Dot__Group_1__0 : rule__Dot__Group_1__0__Impl rule__Dot__Group_1__1 ;
    public final void rule__Dot__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:901:1: ( rule__Dot__Group_1__0__Impl rule__Dot__Group_1__1 )
            // InternalTestScriptDSL.g:902:2: rule__Dot__Group_1__0__Impl rule__Dot__Group_1__1
            {
            pushFollow(FOLLOW_4);
            rule__Dot__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Dot__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group_1__0"


    // $ANTLR start "rule__Dot__Group_1__0__Impl"
    // InternalTestScriptDSL.g:909:1: rule__Dot__Group_1__0__Impl : ( () ) ;
    public final void rule__Dot__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:913:1: ( ( () ) )
            // InternalTestScriptDSL.g:914:1: ( () )
            {
            // InternalTestScriptDSL.g:914:1: ( () )
            // InternalTestScriptDSL.g:915:2: ()
            {
             before(grammarAccess.getDotAccess().getDotLeftAction_1_0()); 
            // InternalTestScriptDSL.g:916:2: ()
            // InternalTestScriptDSL.g:916:3: 
            {
            }

             after(grammarAccess.getDotAccess().getDotLeftAction_1_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group_1__0__Impl"


    // $ANTLR start "rule__Dot__Group_1__1"
    // InternalTestScriptDSL.g:924:1: rule__Dot__Group_1__1 : rule__Dot__Group_1__1__Impl rule__Dot__Group_1__2 ;
    public final void rule__Dot__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:928:1: ( rule__Dot__Group_1__1__Impl rule__Dot__Group_1__2 )
            // InternalTestScriptDSL.g:929:2: rule__Dot__Group_1__1__Impl rule__Dot__Group_1__2
            {
            pushFollow(FOLLOW_8);
            rule__Dot__Group_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Dot__Group_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group_1__1"


    // $ANTLR start "rule__Dot__Group_1__1__Impl"
    // InternalTestScriptDSL.g:936:1: rule__Dot__Group_1__1__Impl : ( ( rule__Dot__OpAssignment_1_1 ) ) ;
    public final void rule__Dot__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:940:1: ( ( ( rule__Dot__OpAssignment_1_1 ) ) )
            // InternalTestScriptDSL.g:941:1: ( ( rule__Dot__OpAssignment_1_1 ) )
            {
            // InternalTestScriptDSL.g:941:1: ( ( rule__Dot__OpAssignment_1_1 ) )
            // InternalTestScriptDSL.g:942:2: ( rule__Dot__OpAssignment_1_1 )
            {
             before(grammarAccess.getDotAccess().getOpAssignment_1_1()); 
            // InternalTestScriptDSL.g:943:2: ( rule__Dot__OpAssignment_1_1 )
            // InternalTestScriptDSL.g:943:3: rule__Dot__OpAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__Dot__OpAssignment_1_1();

            state._fsp--;


            }

             after(grammarAccess.getDotAccess().getOpAssignment_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group_1__1__Impl"


    // $ANTLR start "rule__Dot__Group_1__2"
    // InternalTestScriptDSL.g:951:1: rule__Dot__Group_1__2 : rule__Dot__Group_1__2__Impl ;
    public final void rule__Dot__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:955:1: ( rule__Dot__Group_1__2__Impl )
            // InternalTestScriptDSL.g:956:2: rule__Dot__Group_1__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Dot__Group_1__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group_1__2"


    // $ANTLR start "rule__Dot__Group_1__2__Impl"
    // InternalTestScriptDSL.g:962:1: rule__Dot__Group_1__2__Impl : ( ( rule__Dot__RightAssignment_1_2 ) ) ;
    public final void rule__Dot__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:966:1: ( ( ( rule__Dot__RightAssignment_1_2 ) ) )
            // InternalTestScriptDSL.g:967:1: ( ( rule__Dot__RightAssignment_1_2 ) )
            {
            // InternalTestScriptDSL.g:967:1: ( ( rule__Dot__RightAssignment_1_2 ) )
            // InternalTestScriptDSL.g:968:2: ( rule__Dot__RightAssignment_1_2 )
            {
             before(grammarAccess.getDotAccess().getRightAssignment_1_2()); 
            // InternalTestScriptDSL.g:969:2: ( rule__Dot__RightAssignment_1_2 )
            // InternalTestScriptDSL.g:969:3: rule__Dot__RightAssignment_1_2
            {
            pushFollow(FOLLOW_2);
            rule__Dot__RightAssignment_1_2();

            state._fsp--;


            }

             after(grammarAccess.getDotAccess().getRightAssignment_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__Group_1__2__Impl"


    // $ANTLR start "rule__Array__Group__0"
    // InternalTestScriptDSL.g:978:1: rule__Array__Group__0 : rule__Array__Group__0__Impl rule__Array__Group__1 ;
    public final void rule__Array__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:982:1: ( rule__Array__Group__0__Impl rule__Array__Group__1 )
            // InternalTestScriptDSL.g:983:2: rule__Array__Group__0__Impl rule__Array__Group__1
            {
            pushFollow(FOLLOW_9);
            rule__Array__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Array__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group__0"


    // $ANTLR start "rule__Array__Group__0__Impl"
    // InternalTestScriptDSL.g:990:1: rule__Array__Group__0__Impl : ( ( rule__Array__LeftAssignment_0 ) ) ;
    public final void rule__Array__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:994:1: ( ( ( rule__Array__LeftAssignment_0 ) ) )
            // InternalTestScriptDSL.g:995:1: ( ( rule__Array__LeftAssignment_0 ) )
            {
            // InternalTestScriptDSL.g:995:1: ( ( rule__Array__LeftAssignment_0 ) )
            // InternalTestScriptDSL.g:996:2: ( rule__Array__LeftAssignment_0 )
            {
             before(grammarAccess.getArrayAccess().getLeftAssignment_0()); 
            // InternalTestScriptDSL.g:997:2: ( rule__Array__LeftAssignment_0 )
            // InternalTestScriptDSL.g:997:3: rule__Array__LeftAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Array__LeftAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getArrayAccess().getLeftAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group__0__Impl"


    // $ANTLR start "rule__Array__Group__1"
    // InternalTestScriptDSL.g:1005:1: rule__Array__Group__1 : rule__Array__Group__1__Impl ;
    public final void rule__Array__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1009:1: ( rule__Array__Group__1__Impl )
            // InternalTestScriptDSL.g:1010:2: rule__Array__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Array__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group__1"


    // $ANTLR start "rule__Array__Group__1__Impl"
    // InternalTestScriptDSL.g:1016:1: rule__Array__Group__1__Impl : ( ( rule__Array__Group_1__0 )* ) ;
    public final void rule__Array__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1020:1: ( ( ( rule__Array__Group_1__0 )* ) )
            // InternalTestScriptDSL.g:1021:1: ( ( rule__Array__Group_1__0 )* )
            {
            // InternalTestScriptDSL.g:1021:1: ( ( rule__Array__Group_1__0 )* )
            // InternalTestScriptDSL.g:1022:2: ( rule__Array__Group_1__0 )*
            {
             before(grammarAccess.getArrayAccess().getGroup_1()); 
            // InternalTestScriptDSL.g:1023:2: ( rule__Array__Group_1__0 )*
            loop11:
            do {
                int alt11=2;
                int LA11_0 = input.LA(1);

                if ( (LA11_0==23) ) {
                    alt11=1;
                }


                switch (alt11) {
            	case 1 :
            	    // InternalTestScriptDSL.g:1023:3: rule__Array__Group_1__0
            	    {
            	    pushFollow(FOLLOW_10);
            	    rule__Array__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop11;
                }
            } while (true);

             after(grammarAccess.getArrayAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group__1__Impl"


    // $ANTLR start "rule__Array__Group_1__0"
    // InternalTestScriptDSL.g:1032:1: rule__Array__Group_1__0 : rule__Array__Group_1__0__Impl rule__Array__Group_1__1 ;
    public final void rule__Array__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1036:1: ( rule__Array__Group_1__0__Impl rule__Array__Group_1__1 )
            // InternalTestScriptDSL.g:1037:2: rule__Array__Group_1__0__Impl rule__Array__Group_1__1
            {
            pushFollow(FOLLOW_9);
            rule__Array__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Array__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group_1__0"


    // $ANTLR start "rule__Array__Group_1__0__Impl"
    // InternalTestScriptDSL.g:1044:1: rule__Array__Group_1__0__Impl : ( () ) ;
    public final void rule__Array__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1048:1: ( ( () ) )
            // InternalTestScriptDSL.g:1049:1: ( () )
            {
            // InternalTestScriptDSL.g:1049:1: ( () )
            // InternalTestScriptDSL.g:1050:2: ()
            {
             before(grammarAccess.getArrayAccess().getArrayLeftAction_1_0()); 
            // InternalTestScriptDSL.g:1051:2: ()
            // InternalTestScriptDSL.g:1051:3: 
            {
            }

             after(grammarAccess.getArrayAccess().getArrayLeftAction_1_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group_1__0__Impl"


    // $ANTLR start "rule__Array__Group_1__1"
    // InternalTestScriptDSL.g:1059:1: rule__Array__Group_1__1 : rule__Array__Group_1__1__Impl rule__Array__Group_1__2 ;
    public final void rule__Array__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1063:1: ( rule__Array__Group_1__1__Impl rule__Array__Group_1__2 )
            // InternalTestScriptDSL.g:1064:2: rule__Array__Group_1__1__Impl rule__Array__Group_1__2
            {
            pushFollow(FOLLOW_8);
            rule__Array__Group_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Array__Group_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group_1__1"


    // $ANTLR start "rule__Array__Group_1__1__Impl"
    // InternalTestScriptDSL.g:1071:1: rule__Array__Group_1__1__Impl : ( ( rule__Array__OpAssignment_1_1 ) ) ;
    public final void rule__Array__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1075:1: ( ( ( rule__Array__OpAssignment_1_1 ) ) )
            // InternalTestScriptDSL.g:1076:1: ( ( rule__Array__OpAssignment_1_1 ) )
            {
            // InternalTestScriptDSL.g:1076:1: ( ( rule__Array__OpAssignment_1_1 ) )
            // InternalTestScriptDSL.g:1077:2: ( rule__Array__OpAssignment_1_1 )
            {
             before(grammarAccess.getArrayAccess().getOpAssignment_1_1()); 
            // InternalTestScriptDSL.g:1078:2: ( rule__Array__OpAssignment_1_1 )
            // InternalTestScriptDSL.g:1078:3: rule__Array__OpAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__Array__OpAssignment_1_1();

            state._fsp--;


            }

             after(grammarAccess.getArrayAccess().getOpAssignment_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group_1__1__Impl"


    // $ANTLR start "rule__Array__Group_1__2"
    // InternalTestScriptDSL.g:1086:1: rule__Array__Group_1__2 : rule__Array__Group_1__2__Impl rule__Array__Group_1__3 ;
    public final void rule__Array__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1090:1: ( rule__Array__Group_1__2__Impl rule__Array__Group_1__3 )
            // InternalTestScriptDSL.g:1091:2: rule__Array__Group_1__2__Impl rule__Array__Group_1__3
            {
            pushFollow(FOLLOW_11);
            rule__Array__Group_1__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Array__Group_1__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group_1__2"


    // $ANTLR start "rule__Array__Group_1__2__Impl"
    // InternalTestScriptDSL.g:1098:1: rule__Array__Group_1__2__Impl : ( ( rule__Array__RightAssignment_1_2 ) ) ;
    public final void rule__Array__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1102:1: ( ( ( rule__Array__RightAssignment_1_2 ) ) )
            // InternalTestScriptDSL.g:1103:1: ( ( rule__Array__RightAssignment_1_2 ) )
            {
            // InternalTestScriptDSL.g:1103:1: ( ( rule__Array__RightAssignment_1_2 ) )
            // InternalTestScriptDSL.g:1104:2: ( rule__Array__RightAssignment_1_2 )
            {
             before(grammarAccess.getArrayAccess().getRightAssignment_1_2()); 
            // InternalTestScriptDSL.g:1105:2: ( rule__Array__RightAssignment_1_2 )
            // InternalTestScriptDSL.g:1105:3: rule__Array__RightAssignment_1_2
            {
            pushFollow(FOLLOW_2);
            rule__Array__RightAssignment_1_2();

            state._fsp--;


            }

             after(grammarAccess.getArrayAccess().getRightAssignment_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group_1__2__Impl"


    // $ANTLR start "rule__Array__Group_1__3"
    // InternalTestScriptDSL.g:1113:1: rule__Array__Group_1__3 : rule__Array__Group_1__3__Impl ;
    public final void rule__Array__Group_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1117:1: ( rule__Array__Group_1__3__Impl )
            // InternalTestScriptDSL.g:1118:2: rule__Array__Group_1__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Array__Group_1__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group_1__3"


    // $ANTLR start "rule__Array__Group_1__3__Impl"
    // InternalTestScriptDSL.g:1124:1: rule__Array__Group_1__3__Impl : ( ']' ) ;
    public final void rule__Array__Group_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1128:1: ( ( ']' ) )
            // InternalTestScriptDSL.g:1129:1: ( ']' )
            {
            // InternalTestScriptDSL.g:1129:1: ( ']' )
            // InternalTestScriptDSL.g:1130:2: ']'
            {
             before(grammarAccess.getArrayAccess().getRightSquareBracketKeyword_1_3()); 
            match(input,21,FOLLOW_2); 
             after(grammarAccess.getArrayAccess().getRightSquareBracketKeyword_1_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__Group_1__3__Impl"


    // $ANTLR start "rule__Primary__Group_0__0"
    // InternalTestScriptDSL.g:1140:1: rule__Primary__Group_0__0 : rule__Primary__Group_0__0__Impl rule__Primary__Group_0__1 ;
    public final void rule__Primary__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1144:1: ( rule__Primary__Group_0__0__Impl rule__Primary__Group_0__1 )
            // InternalTestScriptDSL.g:1145:2: rule__Primary__Group_0__0__Impl rule__Primary__Group_0__1
            {
            pushFollow(FOLLOW_8);
            rule__Primary__Group_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Primary__Group_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__Group_0__0"


    // $ANTLR start "rule__Primary__Group_0__0__Impl"
    // InternalTestScriptDSL.g:1152:1: rule__Primary__Group_0__0__Impl : ( ( rule__Primary__OpAssignment_0_0 ) ) ;
    public final void rule__Primary__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1156:1: ( ( ( rule__Primary__OpAssignment_0_0 ) ) )
            // InternalTestScriptDSL.g:1157:1: ( ( rule__Primary__OpAssignment_0_0 ) )
            {
            // InternalTestScriptDSL.g:1157:1: ( ( rule__Primary__OpAssignment_0_0 ) )
            // InternalTestScriptDSL.g:1158:2: ( rule__Primary__OpAssignment_0_0 )
            {
             before(grammarAccess.getPrimaryAccess().getOpAssignment_0_0()); 
            // InternalTestScriptDSL.g:1159:2: ( rule__Primary__OpAssignment_0_0 )
            // InternalTestScriptDSL.g:1159:3: rule__Primary__OpAssignment_0_0
            {
            pushFollow(FOLLOW_2);
            rule__Primary__OpAssignment_0_0();

            state._fsp--;


            }

             after(grammarAccess.getPrimaryAccess().getOpAssignment_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__Group_0__0__Impl"


    // $ANTLR start "rule__Primary__Group_0__1"
    // InternalTestScriptDSL.g:1167:1: rule__Primary__Group_0__1 : rule__Primary__Group_0__1__Impl rule__Primary__Group_0__2 ;
    public final void rule__Primary__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1171:1: ( rule__Primary__Group_0__1__Impl rule__Primary__Group_0__2 )
            // InternalTestScriptDSL.g:1172:2: rule__Primary__Group_0__1__Impl rule__Primary__Group_0__2
            {
            pushFollow(FOLLOW_12);
            rule__Primary__Group_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Primary__Group_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__Group_0__1"


    // $ANTLR start "rule__Primary__Group_0__1__Impl"
    // InternalTestScriptDSL.g:1179:1: rule__Primary__Group_0__1__Impl : ( ( rule__Primary__LeftAssignment_0_1 ) ) ;
    public final void rule__Primary__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1183:1: ( ( ( rule__Primary__LeftAssignment_0_1 ) ) )
            // InternalTestScriptDSL.g:1184:1: ( ( rule__Primary__LeftAssignment_0_1 ) )
            {
            // InternalTestScriptDSL.g:1184:1: ( ( rule__Primary__LeftAssignment_0_1 ) )
            // InternalTestScriptDSL.g:1185:2: ( rule__Primary__LeftAssignment_0_1 )
            {
             before(grammarAccess.getPrimaryAccess().getLeftAssignment_0_1()); 
            // InternalTestScriptDSL.g:1186:2: ( rule__Primary__LeftAssignment_0_1 )
            // InternalTestScriptDSL.g:1186:3: rule__Primary__LeftAssignment_0_1
            {
            pushFollow(FOLLOW_2);
            rule__Primary__LeftAssignment_0_1();

            state._fsp--;


            }

             after(grammarAccess.getPrimaryAccess().getLeftAssignment_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__Group_0__1__Impl"


    // $ANTLR start "rule__Primary__Group_0__2"
    // InternalTestScriptDSL.g:1194:1: rule__Primary__Group_0__2 : rule__Primary__Group_0__2__Impl ;
    public final void rule__Primary__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1198:1: ( rule__Primary__Group_0__2__Impl )
            // InternalTestScriptDSL.g:1199:2: rule__Primary__Group_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Primary__Group_0__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__Group_0__2"


    // $ANTLR start "rule__Primary__Group_0__2__Impl"
    // InternalTestScriptDSL.g:1205:1: rule__Primary__Group_0__2__Impl : ( ')' ) ;
    public final void rule__Primary__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1209:1: ( ( ')' ) )
            // InternalTestScriptDSL.g:1210:1: ( ')' )
            {
            // InternalTestScriptDSL.g:1210:1: ( ')' )
            // InternalTestScriptDSL.g:1211:2: ')'
            {
             before(grammarAccess.getPrimaryAccess().getRightParenthesisKeyword_0_2()); 
            match(input,22,FOLLOW_2); 
             after(grammarAccess.getPrimaryAccess().getRightParenthesisKeyword_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__Group_0__2__Impl"


    // $ANTLR start "rule__Equal__Group__0"
    // InternalTestScriptDSL.g:1221:1: rule__Equal__Group__0 : rule__Equal__Group__0__Impl rule__Equal__Group__1 ;
    public final void rule__Equal__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1225:1: ( rule__Equal__Group__0__Impl rule__Equal__Group__1 )
            // InternalTestScriptDSL.g:1226:2: rule__Equal__Group__0__Impl rule__Equal__Group__1
            {
            pushFollow(FOLLOW_13);
            rule__Equal__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Equal__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group__0"


    // $ANTLR start "rule__Equal__Group__0__Impl"
    // InternalTestScriptDSL.g:1233:1: rule__Equal__Group__0__Impl : ( ( rule__Equal__LeftAssignment_0 ) ) ;
    public final void rule__Equal__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1237:1: ( ( ( rule__Equal__LeftAssignment_0 ) ) )
            // InternalTestScriptDSL.g:1238:1: ( ( rule__Equal__LeftAssignment_0 ) )
            {
            // InternalTestScriptDSL.g:1238:1: ( ( rule__Equal__LeftAssignment_0 ) )
            // InternalTestScriptDSL.g:1239:2: ( rule__Equal__LeftAssignment_0 )
            {
             before(grammarAccess.getEqualAccess().getLeftAssignment_0()); 
            // InternalTestScriptDSL.g:1240:2: ( rule__Equal__LeftAssignment_0 )
            // InternalTestScriptDSL.g:1240:3: rule__Equal__LeftAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Equal__LeftAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getEqualAccess().getLeftAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group__0__Impl"


    // $ANTLR start "rule__Equal__Group__1"
    // InternalTestScriptDSL.g:1248:1: rule__Equal__Group__1 : rule__Equal__Group__1__Impl ;
    public final void rule__Equal__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1252:1: ( rule__Equal__Group__1__Impl )
            // InternalTestScriptDSL.g:1253:2: rule__Equal__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Equal__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group__1"


    // $ANTLR start "rule__Equal__Group__1__Impl"
    // InternalTestScriptDSL.g:1259:1: rule__Equal__Group__1__Impl : ( ( rule__Equal__Group_1__0 )* ) ;
    public final void rule__Equal__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1263:1: ( ( ( rule__Equal__Group_1__0 )* ) )
            // InternalTestScriptDSL.g:1264:1: ( ( rule__Equal__Group_1__0 )* )
            {
            // InternalTestScriptDSL.g:1264:1: ( ( rule__Equal__Group_1__0 )* )
            // InternalTestScriptDSL.g:1265:2: ( rule__Equal__Group_1__0 )*
            {
             before(grammarAccess.getEqualAccess().getGroup_1()); 
            // InternalTestScriptDSL.g:1266:2: ( rule__Equal__Group_1__0 )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==25) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // InternalTestScriptDSL.g:1266:3: rule__Equal__Group_1__0
            	    {
            	    pushFollow(FOLLOW_14);
            	    rule__Equal__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);

             after(grammarAccess.getEqualAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group__1__Impl"


    // $ANTLR start "rule__Equal__Group_1__0"
    // InternalTestScriptDSL.g:1275:1: rule__Equal__Group_1__0 : rule__Equal__Group_1__0__Impl rule__Equal__Group_1__1 ;
    public final void rule__Equal__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1279:1: ( rule__Equal__Group_1__0__Impl rule__Equal__Group_1__1 )
            // InternalTestScriptDSL.g:1280:2: rule__Equal__Group_1__0__Impl rule__Equal__Group_1__1
            {
            pushFollow(FOLLOW_13);
            rule__Equal__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Equal__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group_1__0"


    // $ANTLR start "rule__Equal__Group_1__0__Impl"
    // InternalTestScriptDSL.g:1287:1: rule__Equal__Group_1__0__Impl : ( () ) ;
    public final void rule__Equal__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1291:1: ( ( () ) )
            // InternalTestScriptDSL.g:1292:1: ( () )
            {
            // InternalTestScriptDSL.g:1292:1: ( () )
            // InternalTestScriptDSL.g:1293:2: ()
            {
             before(grammarAccess.getEqualAccess().getEuqalLeftAction_1_0()); 
            // InternalTestScriptDSL.g:1294:2: ()
            // InternalTestScriptDSL.g:1294:3: 
            {
            }

             after(grammarAccess.getEqualAccess().getEuqalLeftAction_1_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group_1__0__Impl"


    // $ANTLR start "rule__Equal__Group_1__1"
    // InternalTestScriptDSL.g:1302:1: rule__Equal__Group_1__1 : rule__Equal__Group_1__1__Impl rule__Equal__Group_1__2 ;
    public final void rule__Equal__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1306:1: ( rule__Equal__Group_1__1__Impl rule__Equal__Group_1__2 )
            // InternalTestScriptDSL.g:1307:2: rule__Equal__Group_1__1__Impl rule__Equal__Group_1__2
            {
            pushFollow(FOLLOW_8);
            rule__Equal__Group_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Equal__Group_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group_1__1"


    // $ANTLR start "rule__Equal__Group_1__1__Impl"
    // InternalTestScriptDSL.g:1314:1: rule__Equal__Group_1__1__Impl : ( ( rule__Equal__OpAssignment_1_1 ) ) ;
    public final void rule__Equal__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1318:1: ( ( ( rule__Equal__OpAssignment_1_1 ) ) )
            // InternalTestScriptDSL.g:1319:1: ( ( rule__Equal__OpAssignment_1_1 ) )
            {
            // InternalTestScriptDSL.g:1319:1: ( ( rule__Equal__OpAssignment_1_1 ) )
            // InternalTestScriptDSL.g:1320:2: ( rule__Equal__OpAssignment_1_1 )
            {
             before(grammarAccess.getEqualAccess().getOpAssignment_1_1()); 
            // InternalTestScriptDSL.g:1321:2: ( rule__Equal__OpAssignment_1_1 )
            // InternalTestScriptDSL.g:1321:3: rule__Equal__OpAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__Equal__OpAssignment_1_1();

            state._fsp--;


            }

             after(grammarAccess.getEqualAccess().getOpAssignment_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group_1__1__Impl"


    // $ANTLR start "rule__Equal__Group_1__2"
    // InternalTestScriptDSL.g:1329:1: rule__Equal__Group_1__2 : rule__Equal__Group_1__2__Impl ;
    public final void rule__Equal__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1333:1: ( rule__Equal__Group_1__2__Impl )
            // InternalTestScriptDSL.g:1334:2: rule__Equal__Group_1__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Equal__Group_1__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group_1__2"


    // $ANTLR start "rule__Equal__Group_1__2__Impl"
    // InternalTestScriptDSL.g:1340:1: rule__Equal__Group_1__2__Impl : ( ( rule__Equal__RightAssignment_1_2 ) ) ;
    public final void rule__Equal__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1344:1: ( ( ( rule__Equal__RightAssignment_1_2 ) ) )
            // InternalTestScriptDSL.g:1345:1: ( ( rule__Equal__RightAssignment_1_2 ) )
            {
            // InternalTestScriptDSL.g:1345:1: ( ( rule__Equal__RightAssignment_1_2 ) )
            // InternalTestScriptDSL.g:1346:2: ( rule__Equal__RightAssignment_1_2 )
            {
             before(grammarAccess.getEqualAccess().getRightAssignment_1_2()); 
            // InternalTestScriptDSL.g:1347:2: ( rule__Equal__RightAssignment_1_2 )
            // InternalTestScriptDSL.g:1347:3: rule__Equal__RightAssignment_1_2
            {
            pushFollow(FOLLOW_2);
            rule__Equal__RightAssignment_1_2();

            state._fsp--;


            }

             after(grammarAccess.getEqualAccess().getRightAssignment_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__Group_1__2__Impl"


    // $ANTLR start "rule__AddAndSub__Group__0"
    // InternalTestScriptDSL.g:1356:1: rule__AddAndSub__Group__0 : rule__AddAndSub__Group__0__Impl rule__AddAndSub__Group__1 ;
    public final void rule__AddAndSub__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1360:1: ( rule__AddAndSub__Group__0__Impl rule__AddAndSub__Group__1 )
            // InternalTestScriptDSL.g:1361:2: rule__AddAndSub__Group__0__Impl rule__AddAndSub__Group__1
            {
            pushFollow(FOLLOW_15);
            rule__AddAndSub__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AddAndSub__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group__0"


    // $ANTLR start "rule__AddAndSub__Group__0__Impl"
    // InternalTestScriptDSL.g:1368:1: rule__AddAndSub__Group__0__Impl : ( ( rule__AddAndSub__LeftAssignment_0 ) ) ;
    public final void rule__AddAndSub__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1372:1: ( ( ( rule__AddAndSub__LeftAssignment_0 ) ) )
            // InternalTestScriptDSL.g:1373:1: ( ( rule__AddAndSub__LeftAssignment_0 ) )
            {
            // InternalTestScriptDSL.g:1373:1: ( ( rule__AddAndSub__LeftAssignment_0 ) )
            // InternalTestScriptDSL.g:1374:2: ( rule__AddAndSub__LeftAssignment_0 )
            {
             before(grammarAccess.getAddAndSubAccess().getLeftAssignment_0()); 
            // InternalTestScriptDSL.g:1375:2: ( rule__AddAndSub__LeftAssignment_0 )
            // InternalTestScriptDSL.g:1375:3: rule__AddAndSub__LeftAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__AddAndSub__LeftAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getAddAndSubAccess().getLeftAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group__0__Impl"


    // $ANTLR start "rule__AddAndSub__Group__1"
    // InternalTestScriptDSL.g:1383:1: rule__AddAndSub__Group__1 : rule__AddAndSub__Group__1__Impl ;
    public final void rule__AddAndSub__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1387:1: ( rule__AddAndSub__Group__1__Impl )
            // InternalTestScriptDSL.g:1388:2: rule__AddAndSub__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AddAndSub__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group__1"


    // $ANTLR start "rule__AddAndSub__Group__1__Impl"
    // InternalTestScriptDSL.g:1394:1: rule__AddAndSub__Group__1__Impl : ( ( rule__AddAndSub__Group_1__0 )* ) ;
    public final void rule__AddAndSub__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1398:1: ( ( ( rule__AddAndSub__Group_1__0 )* ) )
            // InternalTestScriptDSL.g:1399:1: ( ( rule__AddAndSub__Group_1__0 )* )
            {
            // InternalTestScriptDSL.g:1399:1: ( ( rule__AddAndSub__Group_1__0 )* )
            // InternalTestScriptDSL.g:1400:2: ( rule__AddAndSub__Group_1__0 )*
            {
             before(grammarAccess.getAddAndSubAccess().getGroup_1()); 
            // InternalTestScriptDSL.g:1401:2: ( rule__AddAndSub__Group_1__0 )*
            loop13:
            do {
                int alt13=2;
                int LA13_0 = input.LA(1);

                if ( ((LA13_0>=14 && LA13_0<=15)) ) {
                    alt13=1;
                }


                switch (alt13) {
            	case 1 :
            	    // InternalTestScriptDSL.g:1401:3: rule__AddAndSub__Group_1__0
            	    {
            	    pushFollow(FOLLOW_16);
            	    rule__AddAndSub__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);

             after(grammarAccess.getAddAndSubAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group__1__Impl"


    // $ANTLR start "rule__AddAndSub__Group_1__0"
    // InternalTestScriptDSL.g:1410:1: rule__AddAndSub__Group_1__0 : rule__AddAndSub__Group_1__0__Impl rule__AddAndSub__Group_1__1 ;
    public final void rule__AddAndSub__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1414:1: ( rule__AddAndSub__Group_1__0__Impl rule__AddAndSub__Group_1__1 )
            // InternalTestScriptDSL.g:1415:2: rule__AddAndSub__Group_1__0__Impl rule__AddAndSub__Group_1__1
            {
            pushFollow(FOLLOW_15);
            rule__AddAndSub__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AddAndSub__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group_1__0"


    // $ANTLR start "rule__AddAndSub__Group_1__0__Impl"
    // InternalTestScriptDSL.g:1422:1: rule__AddAndSub__Group_1__0__Impl : ( () ) ;
    public final void rule__AddAndSub__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1426:1: ( ( () ) )
            // InternalTestScriptDSL.g:1427:1: ( () )
            {
            // InternalTestScriptDSL.g:1427:1: ( () )
            // InternalTestScriptDSL.g:1428:2: ()
            {
             before(grammarAccess.getAddAndSubAccess().getAddAndSubLeftAction_1_0()); 
            // InternalTestScriptDSL.g:1429:2: ()
            // InternalTestScriptDSL.g:1429:3: 
            {
            }

             after(grammarAccess.getAddAndSubAccess().getAddAndSubLeftAction_1_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group_1__0__Impl"


    // $ANTLR start "rule__AddAndSub__Group_1__1"
    // InternalTestScriptDSL.g:1437:1: rule__AddAndSub__Group_1__1 : rule__AddAndSub__Group_1__1__Impl rule__AddAndSub__Group_1__2 ;
    public final void rule__AddAndSub__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1441:1: ( rule__AddAndSub__Group_1__1__Impl rule__AddAndSub__Group_1__2 )
            // InternalTestScriptDSL.g:1442:2: rule__AddAndSub__Group_1__1__Impl rule__AddAndSub__Group_1__2
            {
            pushFollow(FOLLOW_8);
            rule__AddAndSub__Group_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AddAndSub__Group_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group_1__1"


    // $ANTLR start "rule__AddAndSub__Group_1__1__Impl"
    // InternalTestScriptDSL.g:1449:1: rule__AddAndSub__Group_1__1__Impl : ( ( rule__AddAndSub__OpAssignment_1_1 ) ) ;
    public final void rule__AddAndSub__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1453:1: ( ( ( rule__AddAndSub__OpAssignment_1_1 ) ) )
            // InternalTestScriptDSL.g:1454:1: ( ( rule__AddAndSub__OpAssignment_1_1 ) )
            {
            // InternalTestScriptDSL.g:1454:1: ( ( rule__AddAndSub__OpAssignment_1_1 ) )
            // InternalTestScriptDSL.g:1455:2: ( rule__AddAndSub__OpAssignment_1_1 )
            {
             before(grammarAccess.getAddAndSubAccess().getOpAssignment_1_1()); 
            // InternalTestScriptDSL.g:1456:2: ( rule__AddAndSub__OpAssignment_1_1 )
            // InternalTestScriptDSL.g:1456:3: rule__AddAndSub__OpAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__AddAndSub__OpAssignment_1_1();

            state._fsp--;


            }

             after(grammarAccess.getAddAndSubAccess().getOpAssignment_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group_1__1__Impl"


    // $ANTLR start "rule__AddAndSub__Group_1__2"
    // InternalTestScriptDSL.g:1464:1: rule__AddAndSub__Group_1__2 : rule__AddAndSub__Group_1__2__Impl ;
    public final void rule__AddAndSub__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1468:1: ( rule__AddAndSub__Group_1__2__Impl )
            // InternalTestScriptDSL.g:1469:2: rule__AddAndSub__Group_1__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AddAndSub__Group_1__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group_1__2"


    // $ANTLR start "rule__AddAndSub__Group_1__2__Impl"
    // InternalTestScriptDSL.g:1475:1: rule__AddAndSub__Group_1__2__Impl : ( ( rule__AddAndSub__RightAssignment_1_2 ) ) ;
    public final void rule__AddAndSub__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1479:1: ( ( ( rule__AddAndSub__RightAssignment_1_2 ) ) )
            // InternalTestScriptDSL.g:1480:1: ( ( rule__AddAndSub__RightAssignment_1_2 ) )
            {
            // InternalTestScriptDSL.g:1480:1: ( ( rule__AddAndSub__RightAssignment_1_2 ) )
            // InternalTestScriptDSL.g:1481:2: ( rule__AddAndSub__RightAssignment_1_2 )
            {
             before(grammarAccess.getAddAndSubAccess().getRightAssignment_1_2()); 
            // InternalTestScriptDSL.g:1482:2: ( rule__AddAndSub__RightAssignment_1_2 )
            // InternalTestScriptDSL.g:1482:3: rule__AddAndSub__RightAssignment_1_2
            {
            pushFollow(FOLLOW_2);
            rule__AddAndSub__RightAssignment_1_2();

            state._fsp--;


            }

             after(grammarAccess.getAddAndSubAccess().getRightAssignment_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__Group_1__2__Impl"


    // $ANTLR start "rule__MulAndDiv__Group__0"
    // InternalTestScriptDSL.g:1491:1: rule__MulAndDiv__Group__0 : rule__MulAndDiv__Group__0__Impl rule__MulAndDiv__Group__1 ;
    public final void rule__MulAndDiv__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1495:1: ( rule__MulAndDiv__Group__0__Impl rule__MulAndDiv__Group__1 )
            // InternalTestScriptDSL.g:1496:2: rule__MulAndDiv__Group__0__Impl rule__MulAndDiv__Group__1
            {
            pushFollow(FOLLOW_17);
            rule__MulAndDiv__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__MulAndDiv__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group__0"


    // $ANTLR start "rule__MulAndDiv__Group__0__Impl"
    // InternalTestScriptDSL.g:1503:1: rule__MulAndDiv__Group__0__Impl : ( ( rule__MulAndDiv__LeftAssignment_0 ) ) ;
    public final void rule__MulAndDiv__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1507:1: ( ( ( rule__MulAndDiv__LeftAssignment_0 ) ) )
            // InternalTestScriptDSL.g:1508:1: ( ( rule__MulAndDiv__LeftAssignment_0 ) )
            {
            // InternalTestScriptDSL.g:1508:1: ( ( rule__MulAndDiv__LeftAssignment_0 ) )
            // InternalTestScriptDSL.g:1509:2: ( rule__MulAndDiv__LeftAssignment_0 )
            {
             before(grammarAccess.getMulAndDivAccess().getLeftAssignment_0()); 
            // InternalTestScriptDSL.g:1510:2: ( rule__MulAndDiv__LeftAssignment_0 )
            // InternalTestScriptDSL.g:1510:3: rule__MulAndDiv__LeftAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__MulAndDiv__LeftAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getMulAndDivAccess().getLeftAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group__0__Impl"


    // $ANTLR start "rule__MulAndDiv__Group__1"
    // InternalTestScriptDSL.g:1518:1: rule__MulAndDiv__Group__1 : rule__MulAndDiv__Group__1__Impl ;
    public final void rule__MulAndDiv__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1522:1: ( rule__MulAndDiv__Group__1__Impl )
            // InternalTestScriptDSL.g:1523:2: rule__MulAndDiv__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__MulAndDiv__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group__1"


    // $ANTLR start "rule__MulAndDiv__Group__1__Impl"
    // InternalTestScriptDSL.g:1529:1: rule__MulAndDiv__Group__1__Impl : ( ( rule__MulAndDiv__Group_1__0 )* ) ;
    public final void rule__MulAndDiv__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1533:1: ( ( ( rule__MulAndDiv__Group_1__0 )* ) )
            // InternalTestScriptDSL.g:1534:1: ( ( rule__MulAndDiv__Group_1__0 )* )
            {
            // InternalTestScriptDSL.g:1534:1: ( ( rule__MulAndDiv__Group_1__0 )* )
            // InternalTestScriptDSL.g:1535:2: ( rule__MulAndDiv__Group_1__0 )*
            {
             before(grammarAccess.getMulAndDivAccess().getGroup_1()); 
            // InternalTestScriptDSL.g:1536:2: ( rule__MulAndDiv__Group_1__0 )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);

                if ( ((LA14_0>=16 && LA14_0<=17)) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // InternalTestScriptDSL.g:1536:3: rule__MulAndDiv__Group_1__0
            	    {
            	    pushFollow(FOLLOW_18);
            	    rule__MulAndDiv__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);

             after(grammarAccess.getMulAndDivAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group__1__Impl"


    // $ANTLR start "rule__MulAndDiv__Group_1__0"
    // InternalTestScriptDSL.g:1545:1: rule__MulAndDiv__Group_1__0 : rule__MulAndDiv__Group_1__0__Impl rule__MulAndDiv__Group_1__1 ;
    public final void rule__MulAndDiv__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1549:1: ( rule__MulAndDiv__Group_1__0__Impl rule__MulAndDiv__Group_1__1 )
            // InternalTestScriptDSL.g:1550:2: rule__MulAndDiv__Group_1__0__Impl rule__MulAndDiv__Group_1__1
            {
            pushFollow(FOLLOW_17);
            rule__MulAndDiv__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__MulAndDiv__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group_1__0"


    // $ANTLR start "rule__MulAndDiv__Group_1__0__Impl"
    // InternalTestScriptDSL.g:1557:1: rule__MulAndDiv__Group_1__0__Impl : ( () ) ;
    public final void rule__MulAndDiv__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1561:1: ( ( () ) )
            // InternalTestScriptDSL.g:1562:1: ( () )
            {
            // InternalTestScriptDSL.g:1562:1: ( () )
            // InternalTestScriptDSL.g:1563:2: ()
            {
             before(grammarAccess.getMulAndDivAccess().getMulAndDivLeftAction_1_0()); 
            // InternalTestScriptDSL.g:1564:2: ()
            // InternalTestScriptDSL.g:1564:3: 
            {
            }

             after(grammarAccess.getMulAndDivAccess().getMulAndDivLeftAction_1_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group_1__0__Impl"


    // $ANTLR start "rule__MulAndDiv__Group_1__1"
    // InternalTestScriptDSL.g:1572:1: rule__MulAndDiv__Group_1__1 : rule__MulAndDiv__Group_1__1__Impl rule__MulAndDiv__Group_1__2 ;
    public final void rule__MulAndDiv__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1576:1: ( rule__MulAndDiv__Group_1__1__Impl rule__MulAndDiv__Group_1__2 )
            // InternalTestScriptDSL.g:1577:2: rule__MulAndDiv__Group_1__1__Impl rule__MulAndDiv__Group_1__2
            {
            pushFollow(FOLLOW_8);
            rule__MulAndDiv__Group_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__MulAndDiv__Group_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group_1__1"


    // $ANTLR start "rule__MulAndDiv__Group_1__1__Impl"
    // InternalTestScriptDSL.g:1584:1: rule__MulAndDiv__Group_1__1__Impl : ( ( rule__MulAndDiv__OpAssignment_1_1 ) ) ;
    public final void rule__MulAndDiv__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1588:1: ( ( ( rule__MulAndDiv__OpAssignment_1_1 ) ) )
            // InternalTestScriptDSL.g:1589:1: ( ( rule__MulAndDiv__OpAssignment_1_1 ) )
            {
            // InternalTestScriptDSL.g:1589:1: ( ( rule__MulAndDiv__OpAssignment_1_1 ) )
            // InternalTestScriptDSL.g:1590:2: ( rule__MulAndDiv__OpAssignment_1_1 )
            {
             before(grammarAccess.getMulAndDivAccess().getOpAssignment_1_1()); 
            // InternalTestScriptDSL.g:1591:2: ( rule__MulAndDiv__OpAssignment_1_1 )
            // InternalTestScriptDSL.g:1591:3: rule__MulAndDiv__OpAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__MulAndDiv__OpAssignment_1_1();

            state._fsp--;


            }

             after(grammarAccess.getMulAndDivAccess().getOpAssignment_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group_1__1__Impl"


    // $ANTLR start "rule__MulAndDiv__Group_1__2"
    // InternalTestScriptDSL.g:1599:1: rule__MulAndDiv__Group_1__2 : rule__MulAndDiv__Group_1__2__Impl ;
    public final void rule__MulAndDiv__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1603:1: ( rule__MulAndDiv__Group_1__2__Impl )
            // InternalTestScriptDSL.g:1604:2: rule__MulAndDiv__Group_1__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__MulAndDiv__Group_1__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group_1__2"


    // $ANTLR start "rule__MulAndDiv__Group_1__2__Impl"
    // InternalTestScriptDSL.g:1610:1: rule__MulAndDiv__Group_1__2__Impl : ( ( rule__MulAndDiv__RightAssignment_1_2 ) ) ;
    public final void rule__MulAndDiv__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1614:1: ( ( ( rule__MulAndDiv__RightAssignment_1_2 ) ) )
            // InternalTestScriptDSL.g:1615:1: ( ( rule__MulAndDiv__RightAssignment_1_2 ) )
            {
            // InternalTestScriptDSL.g:1615:1: ( ( rule__MulAndDiv__RightAssignment_1_2 ) )
            // InternalTestScriptDSL.g:1616:2: ( rule__MulAndDiv__RightAssignment_1_2 )
            {
             before(grammarAccess.getMulAndDivAccess().getRightAssignment_1_2()); 
            // InternalTestScriptDSL.g:1617:2: ( rule__MulAndDiv__RightAssignment_1_2 )
            // InternalTestScriptDSL.g:1617:3: rule__MulAndDiv__RightAssignment_1_2
            {
            pushFollow(FOLLOW_2);
            rule__MulAndDiv__RightAssignment_1_2();

            state._fsp--;


            }

             after(grammarAccess.getMulAndDivAccess().getRightAssignment_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__Group_1__2__Impl"


    // $ANTLR start "rule__TestScriptDSL__ElementsAssignment"
    // InternalTestScriptDSL.g:1626:1: rule__TestScriptDSL__ElementsAssignment : ( ruleAbstractElement ) ;
    public final void rule__TestScriptDSL__ElementsAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1630:1: ( ( ruleAbstractElement ) )
            // InternalTestScriptDSL.g:1631:2: ( ruleAbstractElement )
            {
            // InternalTestScriptDSL.g:1631:2: ( ruleAbstractElement )
            // InternalTestScriptDSL.g:1632:3: ruleAbstractElement
            {
             before(grammarAccess.getTestScriptDSLAccess().getElementsAbstractElementParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleAbstractElement();

            state._fsp--;

             after(grammarAccess.getTestScriptDSLAccess().getElementsAbstractElementParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TestScriptDSL__ElementsAssignment"


    // $ANTLR start "rule__AbstractElement__StmtAssignment"
    // InternalTestScriptDSL.g:1641:1: rule__AbstractElement__StmtAssignment : ( ruleStmt ) ;
    public final void rule__AbstractElement__StmtAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1645:1: ( ( ruleStmt ) )
            // InternalTestScriptDSL.g:1646:2: ( ruleStmt )
            {
            // InternalTestScriptDSL.g:1646:2: ( ruleStmt )
            // InternalTestScriptDSL.g:1647:3: ruleStmt
            {
             before(grammarAccess.getAbstractElementAccess().getStmtStmtParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleStmt();

            state._fsp--;

             after(grammarAccess.getAbstractElementAccess().getStmtStmtParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AbstractElement__StmtAssignment"


    // $ANTLR start "rule__Import__ImportedNamespaceAssignment_1"
    // InternalTestScriptDSL.g:1656:1: rule__Import__ImportedNamespaceAssignment_1 : ( ruleQualifiedNameWithWildcard ) ;
    public final void rule__Import__ImportedNamespaceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1660:1: ( ( ruleQualifiedNameWithWildcard ) )
            // InternalTestScriptDSL.g:1661:2: ( ruleQualifiedNameWithWildcard )
            {
            // InternalTestScriptDSL.g:1661:2: ( ruleQualifiedNameWithWildcard )
            // InternalTestScriptDSL.g:1662:3: ruleQualifiedNameWithWildcard
            {
             before(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedNameWithWildcard();

            state._fsp--;

             after(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__ImportedNamespaceAssignment_1"


    // $ANTLR start "rule__Stmt__TypeAssignment"
    // InternalTestScriptDSL.g:1671:1: rule__Stmt__TypeAssignment : ( ( rule__Stmt__TypeAlternatives_0 ) ) ;
    public final void rule__Stmt__TypeAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1675:1: ( ( ( rule__Stmt__TypeAlternatives_0 ) ) )
            // InternalTestScriptDSL.g:1676:2: ( ( rule__Stmt__TypeAlternatives_0 ) )
            {
            // InternalTestScriptDSL.g:1676:2: ( ( rule__Stmt__TypeAlternatives_0 ) )
            // InternalTestScriptDSL.g:1677:3: ( rule__Stmt__TypeAlternatives_0 )
            {
             before(grammarAccess.getStmtAccess().getTypeAlternatives_0()); 
            // InternalTestScriptDSL.g:1678:3: ( rule__Stmt__TypeAlternatives_0 )
            // InternalTestScriptDSL.g:1678:4: rule__Stmt__TypeAlternatives_0
            {
            pushFollow(FOLLOW_2);
            rule__Stmt__TypeAlternatives_0();

            state._fsp--;


            }

             after(grammarAccess.getStmtAccess().getTypeAlternatives_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Stmt__TypeAssignment"


    // $ANTLR start "rule__Exp__LeftAssignment"
    // InternalTestScriptDSL.g:1686:1: rule__Exp__LeftAssignment : ( ruleEqual ) ;
    public final void rule__Exp__LeftAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1690:1: ( ( ruleEqual ) )
            // InternalTestScriptDSL.g:1691:2: ( ruleEqual )
            {
            // InternalTestScriptDSL.g:1691:2: ( ruleEqual )
            // InternalTestScriptDSL.g:1692:3: ruleEqual
            {
             before(grammarAccess.getExpAccess().getLeftEqualParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleEqual();

            state._fsp--;

             after(grammarAccess.getExpAccess().getLeftEqualParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Exp__LeftAssignment"


    // $ANTLR start "rule__Var__NameAssignment"
    // InternalTestScriptDSL.g:1701:1: rule__Var__NameAssignment : ( RULE_ID ) ;
    public final void rule__Var__NameAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1705:1: ( ( RULE_ID ) )
            // InternalTestScriptDSL.g:1706:2: ( RULE_ID )
            {
            // InternalTestScriptDSL.g:1706:2: ( RULE_ID )
            // InternalTestScriptDSL.g:1707:3: RULE_ID
            {
             before(grammarAccess.getVarAccess().getNameIDTerminalRuleCall_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getVarAccess().getNameIDTerminalRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Var__NameAssignment"


    // $ANTLR start "rule__Val__NameAssignment"
    // InternalTestScriptDSL.g:1716:1: rule__Val__NameAssignment : ( ruleQualifiedValue ) ;
    public final void rule__Val__NameAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1720:1: ( ( ruleQualifiedValue ) )
            // InternalTestScriptDSL.g:1721:2: ( ruleQualifiedValue )
            {
            // InternalTestScriptDSL.g:1721:2: ( ruleQualifiedValue )
            // InternalTestScriptDSL.g:1722:3: ruleQualifiedValue
            {
             before(grammarAccess.getValAccess().getNameQualifiedValueParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedValue();

            state._fsp--;

             after(grammarAccess.getValAccess().getNameQualifiedValueParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Val__NameAssignment"


    // $ANTLR start "rule__Dot__LeftAssignment_0"
    // InternalTestScriptDSL.g:1731:1: rule__Dot__LeftAssignment_0 : ( ruleArray ) ;
    public final void rule__Dot__LeftAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1735:1: ( ( ruleArray ) )
            // InternalTestScriptDSL.g:1736:2: ( ruleArray )
            {
            // InternalTestScriptDSL.g:1736:2: ( ruleArray )
            // InternalTestScriptDSL.g:1737:3: ruleArray
            {
             before(grammarAccess.getDotAccess().getLeftArrayParserRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            ruleArray();

            state._fsp--;

             after(grammarAccess.getDotAccess().getLeftArrayParserRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__LeftAssignment_0"


    // $ANTLR start "rule__Dot__OpAssignment_1_1"
    // InternalTestScriptDSL.g:1746:1: rule__Dot__OpAssignment_1_1 : ( ( '.' ) ) ;
    public final void rule__Dot__OpAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1750:1: ( ( ( '.' ) ) )
            // InternalTestScriptDSL.g:1751:2: ( ( '.' ) )
            {
            // InternalTestScriptDSL.g:1751:2: ( ( '.' ) )
            // InternalTestScriptDSL.g:1752:3: ( '.' )
            {
             before(grammarAccess.getDotAccess().getOpFullStopKeyword_1_1_0()); 
            // InternalTestScriptDSL.g:1753:3: ( '.' )
            // InternalTestScriptDSL.g:1754:4: '.'
            {
             before(grammarAccess.getDotAccess().getOpFullStopKeyword_1_1_0()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getDotAccess().getOpFullStopKeyword_1_1_0()); 

            }

             after(grammarAccess.getDotAccess().getOpFullStopKeyword_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__OpAssignment_1_1"


    // $ANTLR start "rule__Dot__RightAssignment_1_2"
    // InternalTestScriptDSL.g:1765:1: rule__Dot__RightAssignment_1_2 : ( ruleArray ) ;
    public final void rule__Dot__RightAssignment_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1769:1: ( ( ruleArray ) )
            // InternalTestScriptDSL.g:1770:2: ( ruleArray )
            {
            // InternalTestScriptDSL.g:1770:2: ( ruleArray )
            // InternalTestScriptDSL.g:1771:3: ruleArray
            {
             before(grammarAccess.getDotAccess().getRightArrayParserRuleCall_1_2_0()); 
            pushFollow(FOLLOW_2);
            ruleArray();

            state._fsp--;

             after(grammarAccess.getDotAccess().getRightArrayParserRuleCall_1_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Dot__RightAssignment_1_2"


    // $ANTLR start "rule__Array__LeftAssignment_0"
    // InternalTestScriptDSL.g:1780:1: rule__Array__LeftAssignment_0 : ( rulePrimary ) ;
    public final void rule__Array__LeftAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1784:1: ( ( rulePrimary ) )
            // InternalTestScriptDSL.g:1785:2: ( rulePrimary )
            {
            // InternalTestScriptDSL.g:1785:2: ( rulePrimary )
            // InternalTestScriptDSL.g:1786:3: rulePrimary
            {
             before(grammarAccess.getArrayAccess().getLeftPrimaryParserRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            rulePrimary();

            state._fsp--;

             after(grammarAccess.getArrayAccess().getLeftPrimaryParserRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__LeftAssignment_0"


    // $ANTLR start "rule__Array__OpAssignment_1_1"
    // InternalTestScriptDSL.g:1795:1: rule__Array__OpAssignment_1_1 : ( ( '[' ) ) ;
    public final void rule__Array__OpAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1799:1: ( ( ( '[' ) ) )
            // InternalTestScriptDSL.g:1800:2: ( ( '[' ) )
            {
            // InternalTestScriptDSL.g:1800:2: ( ( '[' ) )
            // InternalTestScriptDSL.g:1801:3: ( '[' )
            {
             before(grammarAccess.getArrayAccess().getOpLeftSquareBracketKeyword_1_1_0()); 
            // InternalTestScriptDSL.g:1802:3: ( '[' )
            // InternalTestScriptDSL.g:1803:4: '['
            {
             before(grammarAccess.getArrayAccess().getOpLeftSquareBracketKeyword_1_1_0()); 
            match(input,23,FOLLOW_2); 
             after(grammarAccess.getArrayAccess().getOpLeftSquareBracketKeyword_1_1_0()); 

            }

             after(grammarAccess.getArrayAccess().getOpLeftSquareBracketKeyword_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__OpAssignment_1_1"


    // $ANTLR start "rule__Array__RightAssignment_1_2"
    // InternalTestScriptDSL.g:1814:1: rule__Array__RightAssignment_1_2 : ( rulePrimary ) ;
    public final void rule__Array__RightAssignment_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1818:1: ( ( rulePrimary ) )
            // InternalTestScriptDSL.g:1819:2: ( rulePrimary )
            {
            // InternalTestScriptDSL.g:1819:2: ( rulePrimary )
            // InternalTestScriptDSL.g:1820:3: rulePrimary
            {
             before(grammarAccess.getArrayAccess().getRightPrimaryParserRuleCall_1_2_0()); 
            pushFollow(FOLLOW_2);
            rulePrimary();

            state._fsp--;

             after(grammarAccess.getArrayAccess().getRightPrimaryParserRuleCall_1_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Array__RightAssignment_1_2"


    // $ANTLR start "rule__Primary__OpAssignment_0_0"
    // InternalTestScriptDSL.g:1829:1: rule__Primary__OpAssignment_0_0 : ( ( '(' ) ) ;
    public final void rule__Primary__OpAssignment_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1833:1: ( ( ( '(' ) ) )
            // InternalTestScriptDSL.g:1834:2: ( ( '(' ) )
            {
            // InternalTestScriptDSL.g:1834:2: ( ( '(' ) )
            // InternalTestScriptDSL.g:1835:3: ( '(' )
            {
             before(grammarAccess.getPrimaryAccess().getOpLeftParenthesisKeyword_0_0_0()); 
            // InternalTestScriptDSL.g:1836:3: ( '(' )
            // InternalTestScriptDSL.g:1837:4: '('
            {
             before(grammarAccess.getPrimaryAccess().getOpLeftParenthesisKeyword_0_0_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getPrimaryAccess().getOpLeftParenthesisKeyword_0_0_0()); 

            }

             after(grammarAccess.getPrimaryAccess().getOpLeftParenthesisKeyword_0_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__OpAssignment_0_0"


    // $ANTLR start "rule__Primary__LeftAssignment_0_1"
    // InternalTestScriptDSL.g:1848:1: rule__Primary__LeftAssignment_0_1 : ( ruleEqual ) ;
    public final void rule__Primary__LeftAssignment_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1852:1: ( ( ruleEqual ) )
            // InternalTestScriptDSL.g:1853:2: ( ruleEqual )
            {
            // InternalTestScriptDSL.g:1853:2: ( ruleEqual )
            // InternalTestScriptDSL.g:1854:3: ruleEqual
            {
             before(grammarAccess.getPrimaryAccess().getLeftEqualParserRuleCall_0_1_0()); 
            pushFollow(FOLLOW_2);
            ruleEqual();

            state._fsp--;

             after(grammarAccess.getPrimaryAccess().getLeftEqualParserRuleCall_0_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__LeftAssignment_0_1"


    // $ANTLR start "rule__Primary__LeftAssignment_1"
    // InternalTestScriptDSL.g:1863:1: rule__Primary__LeftAssignment_1 : ( ruleVar ) ;
    public final void rule__Primary__LeftAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1867:1: ( ( ruleVar ) )
            // InternalTestScriptDSL.g:1868:2: ( ruleVar )
            {
            // InternalTestScriptDSL.g:1868:2: ( ruleVar )
            // InternalTestScriptDSL.g:1869:3: ruleVar
            {
             before(grammarAccess.getPrimaryAccess().getLeftVarParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleVar();

            state._fsp--;

             after(grammarAccess.getPrimaryAccess().getLeftVarParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__LeftAssignment_1"


    // $ANTLR start "rule__Primary__LeftAssignment_2"
    // InternalTestScriptDSL.g:1878:1: rule__Primary__LeftAssignment_2 : ( ruleVal ) ;
    public final void rule__Primary__LeftAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1882:1: ( ( ruleVal ) )
            // InternalTestScriptDSL.g:1883:2: ( ruleVal )
            {
            // InternalTestScriptDSL.g:1883:2: ( ruleVal )
            // InternalTestScriptDSL.g:1884:3: ruleVal
            {
             before(grammarAccess.getPrimaryAccess().getLeftValParserRuleCall_2_0()); 
            pushFollow(FOLLOW_2);
            ruleVal();

            state._fsp--;

             after(grammarAccess.getPrimaryAccess().getLeftValParserRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Primary__LeftAssignment_2"


    // $ANTLR start "rule__Equal__LeftAssignment_0"
    // InternalTestScriptDSL.g:1893:1: rule__Equal__LeftAssignment_0 : ( ruleAddAndSub ) ;
    public final void rule__Equal__LeftAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1897:1: ( ( ruleAddAndSub ) )
            // InternalTestScriptDSL.g:1898:2: ( ruleAddAndSub )
            {
            // InternalTestScriptDSL.g:1898:2: ( ruleAddAndSub )
            // InternalTestScriptDSL.g:1899:3: ruleAddAndSub
            {
             before(grammarAccess.getEqualAccess().getLeftAddAndSubParserRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            ruleAddAndSub();

            state._fsp--;

             after(grammarAccess.getEqualAccess().getLeftAddAndSubParserRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__LeftAssignment_0"


    // $ANTLR start "rule__Equal__OpAssignment_1_1"
    // InternalTestScriptDSL.g:1908:1: rule__Equal__OpAssignment_1_1 : ( ( '=' ) ) ;
    public final void rule__Equal__OpAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1912:1: ( ( ( '=' ) ) )
            // InternalTestScriptDSL.g:1913:2: ( ( '=' ) )
            {
            // InternalTestScriptDSL.g:1913:2: ( ( '=' ) )
            // InternalTestScriptDSL.g:1914:3: ( '=' )
            {
             before(grammarAccess.getEqualAccess().getOpEqualsSignKeyword_1_1_0()); 
            // InternalTestScriptDSL.g:1915:3: ( '=' )
            // InternalTestScriptDSL.g:1916:4: '='
            {
             before(grammarAccess.getEqualAccess().getOpEqualsSignKeyword_1_1_0()); 
            match(input,25,FOLLOW_2); 
             after(grammarAccess.getEqualAccess().getOpEqualsSignKeyword_1_1_0()); 

            }

             after(grammarAccess.getEqualAccess().getOpEqualsSignKeyword_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__OpAssignment_1_1"


    // $ANTLR start "rule__Equal__RightAssignment_1_2"
    // InternalTestScriptDSL.g:1927:1: rule__Equal__RightAssignment_1_2 : ( ruleAddAndSub ) ;
    public final void rule__Equal__RightAssignment_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1931:1: ( ( ruleAddAndSub ) )
            // InternalTestScriptDSL.g:1932:2: ( ruleAddAndSub )
            {
            // InternalTestScriptDSL.g:1932:2: ( ruleAddAndSub )
            // InternalTestScriptDSL.g:1933:3: ruleAddAndSub
            {
             before(grammarAccess.getEqualAccess().getRightAddAndSubParserRuleCall_1_2_0()); 
            pushFollow(FOLLOW_2);
            ruleAddAndSub();

            state._fsp--;

             after(grammarAccess.getEqualAccess().getRightAddAndSubParserRuleCall_1_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Equal__RightAssignment_1_2"


    // $ANTLR start "rule__AddAndSub__LeftAssignment_0"
    // InternalTestScriptDSL.g:1942:1: rule__AddAndSub__LeftAssignment_0 : ( ruleMulAndDiv ) ;
    public final void rule__AddAndSub__LeftAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1946:1: ( ( ruleMulAndDiv ) )
            // InternalTestScriptDSL.g:1947:2: ( ruleMulAndDiv )
            {
            // InternalTestScriptDSL.g:1947:2: ( ruleMulAndDiv )
            // InternalTestScriptDSL.g:1948:3: ruleMulAndDiv
            {
             before(grammarAccess.getAddAndSubAccess().getLeftMulAndDivParserRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            ruleMulAndDiv();

            state._fsp--;

             after(grammarAccess.getAddAndSubAccess().getLeftMulAndDivParserRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__LeftAssignment_0"


    // $ANTLR start "rule__AddAndSub__OpAssignment_1_1"
    // InternalTestScriptDSL.g:1957:1: rule__AddAndSub__OpAssignment_1_1 : ( ( rule__AddAndSub__OpAlternatives_1_1_0 ) ) ;
    public final void rule__AddAndSub__OpAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1961:1: ( ( ( rule__AddAndSub__OpAlternatives_1_1_0 ) ) )
            // InternalTestScriptDSL.g:1962:2: ( ( rule__AddAndSub__OpAlternatives_1_1_0 ) )
            {
            // InternalTestScriptDSL.g:1962:2: ( ( rule__AddAndSub__OpAlternatives_1_1_0 ) )
            // InternalTestScriptDSL.g:1963:3: ( rule__AddAndSub__OpAlternatives_1_1_0 )
            {
             before(grammarAccess.getAddAndSubAccess().getOpAlternatives_1_1_0()); 
            // InternalTestScriptDSL.g:1964:3: ( rule__AddAndSub__OpAlternatives_1_1_0 )
            // InternalTestScriptDSL.g:1964:4: rule__AddAndSub__OpAlternatives_1_1_0
            {
            pushFollow(FOLLOW_2);
            rule__AddAndSub__OpAlternatives_1_1_0();

            state._fsp--;


            }

             after(grammarAccess.getAddAndSubAccess().getOpAlternatives_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__OpAssignment_1_1"


    // $ANTLR start "rule__AddAndSub__RightAssignment_1_2"
    // InternalTestScriptDSL.g:1972:1: rule__AddAndSub__RightAssignment_1_2 : ( ruleMulAndDiv ) ;
    public final void rule__AddAndSub__RightAssignment_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1976:1: ( ( ruleMulAndDiv ) )
            // InternalTestScriptDSL.g:1977:2: ( ruleMulAndDiv )
            {
            // InternalTestScriptDSL.g:1977:2: ( ruleMulAndDiv )
            // InternalTestScriptDSL.g:1978:3: ruleMulAndDiv
            {
             before(grammarAccess.getAddAndSubAccess().getRightMulAndDivParserRuleCall_1_2_0()); 
            pushFollow(FOLLOW_2);
            ruleMulAndDiv();

            state._fsp--;

             after(grammarAccess.getAddAndSubAccess().getRightMulAndDivParserRuleCall_1_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AddAndSub__RightAssignment_1_2"


    // $ANTLR start "rule__MulAndDiv__LeftAssignment_0"
    // InternalTestScriptDSL.g:1987:1: rule__MulAndDiv__LeftAssignment_0 : ( ruleDot ) ;
    public final void rule__MulAndDiv__LeftAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:1991:1: ( ( ruleDot ) )
            // InternalTestScriptDSL.g:1992:2: ( ruleDot )
            {
            // InternalTestScriptDSL.g:1992:2: ( ruleDot )
            // InternalTestScriptDSL.g:1993:3: ruleDot
            {
             before(grammarAccess.getMulAndDivAccess().getLeftDotParserRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            ruleDot();

            state._fsp--;

             after(grammarAccess.getMulAndDivAccess().getLeftDotParserRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__LeftAssignment_0"


    // $ANTLR start "rule__MulAndDiv__OpAssignment_1_1"
    // InternalTestScriptDSL.g:2002:1: rule__MulAndDiv__OpAssignment_1_1 : ( ( rule__MulAndDiv__OpAlternatives_1_1_0 ) ) ;
    public final void rule__MulAndDiv__OpAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:2006:1: ( ( ( rule__MulAndDiv__OpAlternatives_1_1_0 ) ) )
            // InternalTestScriptDSL.g:2007:2: ( ( rule__MulAndDiv__OpAlternatives_1_1_0 ) )
            {
            // InternalTestScriptDSL.g:2007:2: ( ( rule__MulAndDiv__OpAlternatives_1_1_0 ) )
            // InternalTestScriptDSL.g:2008:3: ( rule__MulAndDiv__OpAlternatives_1_1_0 )
            {
             before(grammarAccess.getMulAndDivAccess().getOpAlternatives_1_1_0()); 
            // InternalTestScriptDSL.g:2009:3: ( rule__MulAndDiv__OpAlternatives_1_1_0 )
            // InternalTestScriptDSL.g:2009:4: rule__MulAndDiv__OpAlternatives_1_1_0
            {
            pushFollow(FOLLOW_2);
            rule__MulAndDiv__OpAlternatives_1_1_0();

            state._fsp--;


            }

             after(grammarAccess.getMulAndDivAccess().getOpAlternatives_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__OpAssignment_1_1"


    // $ANTLR start "rule__MulAndDiv__RightAssignment_1_2"
    // InternalTestScriptDSL.g:2017:1: rule__MulAndDiv__RightAssignment_1_2 : ( ruleDot ) ;
    public final void rule__MulAndDiv__RightAssignment_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalTestScriptDSL.g:2021:1: ( ( ruleDot ) )
            // InternalTestScriptDSL.g:2022:2: ( ruleDot )
            {
            // InternalTestScriptDSL.g:2022:2: ( ruleDot )
            // InternalTestScriptDSL.g:2023:3: ruleDot
            {
             before(grammarAccess.getMulAndDivAccess().getRightDotParserRuleCall_1_2_0()); 
            pushFollow(FOLLOW_2);
            ruleDot();

            state._fsp--;

             after(grammarAccess.getMulAndDivAccess().getRightDotParserRuleCall_1_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__MulAndDiv__RightAssignment_1_2"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000001083872L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000001003870L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000800002L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000002000002L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x000000000000C000L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x000000000000C002L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000030000L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000000030002L});

}