package org.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.services.TestScriptDSLGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalTestScriptDSLParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'.'", "'import'", "'.*'", "'True'", "'False'", "'{}'", "'['", "']'", "'('", "')'", "'='", "'+'", "'-'", "'*'", "'/'"
    };
    public static final int RULE_STRING=6;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=5;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalTestScriptDSLParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalTestScriptDSLParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalTestScriptDSLParser.tokenNames; }
    public String getGrammarFileName() { return "InternalTestScriptDSL.g"; }



     	private TestScriptDSLGrammarAccess grammarAccess;

        public InternalTestScriptDSLParser(TokenStream input, TestScriptDSLGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "TestScriptDSL";
       	}

       	@Override
       	protected TestScriptDSLGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleTestScriptDSL"
    // InternalTestScriptDSL.g:64:1: entryRuleTestScriptDSL returns [EObject current=null] : iv_ruleTestScriptDSL= ruleTestScriptDSL EOF ;
    public final EObject entryRuleTestScriptDSL() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTestScriptDSL = null;


        try {
            // InternalTestScriptDSL.g:64:54: (iv_ruleTestScriptDSL= ruleTestScriptDSL EOF )
            // InternalTestScriptDSL.g:65:2: iv_ruleTestScriptDSL= ruleTestScriptDSL EOF
            {
             newCompositeNode(grammarAccess.getTestScriptDSLRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleTestScriptDSL=ruleTestScriptDSL();

            state._fsp--;

             current =iv_ruleTestScriptDSL; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTestScriptDSL"


    // $ANTLR start "ruleTestScriptDSL"
    // InternalTestScriptDSL.g:71:1: ruleTestScriptDSL returns [EObject current=null] : ( (lv_elements_0_0= ruleAbstractElement ) )* ;
    public final EObject ruleTestScriptDSL() throws RecognitionException {
        EObject current = null;

        EObject lv_elements_0_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:77:2: ( ( (lv_elements_0_0= ruleAbstractElement ) )* )
            // InternalTestScriptDSL.g:78:2: ( (lv_elements_0_0= ruleAbstractElement ) )*
            {
            // InternalTestScriptDSL.g:78:2: ( (lv_elements_0_0= ruleAbstractElement ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=RULE_ID && LA1_0<=RULE_STRING)||LA1_0==12||(LA1_0>=14 && LA1_0<=16)||LA1_0==19) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalTestScriptDSL.g:79:3: (lv_elements_0_0= ruleAbstractElement )
            	    {
            	    // InternalTestScriptDSL.g:79:3: (lv_elements_0_0= ruleAbstractElement )
            	    // InternalTestScriptDSL.g:80:4: lv_elements_0_0= ruleAbstractElement
            	    {

            	    				newCompositeNode(grammarAccess.getTestScriptDSLAccess().getElementsAbstractElementParserRuleCall_0());
            	    			
            	    pushFollow(FOLLOW_3);
            	    lv_elements_0_0=ruleAbstractElement();

            	    state._fsp--;


            	    				if (current==null) {
            	    					current = createModelElementForParent(grammarAccess.getTestScriptDSLRule());
            	    				}
            	    				add(
            	    					current,
            	    					"elements",
            	    					lv_elements_0_0,
            	    					"org.TestScriptDSL.AbstractElement");
            	    				afterParserOrEnumRuleCall();
            	    			

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTestScriptDSL"


    // $ANTLR start "entryRuleAbstractElement"
    // InternalTestScriptDSL.g:100:1: entryRuleAbstractElement returns [EObject current=null] : iv_ruleAbstractElement= ruleAbstractElement EOF ;
    public final EObject entryRuleAbstractElement() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAbstractElement = null;


        try {
            // InternalTestScriptDSL.g:100:56: (iv_ruleAbstractElement= ruleAbstractElement EOF )
            // InternalTestScriptDSL.g:101:2: iv_ruleAbstractElement= ruleAbstractElement EOF
            {
             newCompositeNode(grammarAccess.getAbstractElementRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAbstractElement=ruleAbstractElement();

            state._fsp--;

             current =iv_ruleAbstractElement; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAbstractElement"


    // $ANTLR start "ruleAbstractElement"
    // InternalTestScriptDSL.g:107:1: ruleAbstractElement returns [EObject current=null] : ( (lv_stmt_0_0= ruleStmt ) ) ;
    public final EObject ruleAbstractElement() throws RecognitionException {
        EObject current = null;

        EObject lv_stmt_0_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:113:2: ( ( (lv_stmt_0_0= ruleStmt ) ) )
            // InternalTestScriptDSL.g:114:2: ( (lv_stmt_0_0= ruleStmt ) )
            {
            // InternalTestScriptDSL.g:114:2: ( (lv_stmt_0_0= ruleStmt ) )
            // InternalTestScriptDSL.g:115:3: (lv_stmt_0_0= ruleStmt )
            {
            // InternalTestScriptDSL.g:115:3: (lv_stmt_0_0= ruleStmt )
            // InternalTestScriptDSL.g:116:4: lv_stmt_0_0= ruleStmt
            {

            				newCompositeNode(grammarAccess.getAbstractElementAccess().getStmtStmtParserRuleCall_0());
            			
            pushFollow(FOLLOW_2);
            lv_stmt_0_0=ruleStmt();

            state._fsp--;


            				if (current==null) {
            					current = createModelElementForParent(grammarAccess.getAbstractElementRule());
            				}
            				set(
            					current,
            					"stmt",
            					lv_stmt_0_0,
            					"org.TestScriptDSL.Stmt");
            				afterParserOrEnumRuleCall();
            			

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAbstractElement"


    // $ANTLR start "entryRuleQualifiedName"
    // InternalTestScriptDSL.g:136:1: entryRuleQualifiedName returns [String current=null] : iv_ruleQualifiedName= ruleQualifiedName EOF ;
    public final String entryRuleQualifiedName() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleQualifiedName = null;


        try {
            // InternalTestScriptDSL.g:136:53: (iv_ruleQualifiedName= ruleQualifiedName EOF )
            // InternalTestScriptDSL.g:137:2: iv_ruleQualifiedName= ruleQualifiedName EOF
            {
             newCompositeNode(grammarAccess.getQualifiedNameRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleQualifiedName=ruleQualifiedName();

            state._fsp--;

             current =iv_ruleQualifiedName.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleQualifiedName"


    // $ANTLR start "ruleQualifiedName"
    // InternalTestScriptDSL.g:143:1: ruleQualifiedName returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )* ) ;
    public final AntlrDatatypeRuleToken ruleQualifiedName() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_ID_0=null;
        Token kw=null;
        Token this_ID_2=null;


        	enterRule();

        try {
            // InternalTestScriptDSL.g:149:2: ( (this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )* ) )
            // InternalTestScriptDSL.g:150:2: (this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )* )
            {
            // InternalTestScriptDSL.g:150:2: (this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )* )
            // InternalTestScriptDSL.g:151:3: this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )*
            {
            this_ID_0=(Token)match(input,RULE_ID,FOLLOW_4); 

            			current.merge(this_ID_0);
            		

            			newLeafNode(this_ID_0, grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0());
            		
            // InternalTestScriptDSL.g:158:3: (kw= '.' this_ID_2= RULE_ID )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==11) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // InternalTestScriptDSL.g:159:4: kw= '.' this_ID_2= RULE_ID
            	    {
            	    kw=(Token)match(input,11,FOLLOW_5); 

            	    				current.merge(kw);
            	    				newLeafNode(kw, grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0());
            	    			
            	    this_ID_2=(Token)match(input,RULE_ID,FOLLOW_4); 

            	    				current.merge(this_ID_2);
            	    			

            	    				newLeafNode(this_ID_2, grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1());
            	    			

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleQualifiedName"


    // $ANTLR start "entryRuleImport"
    // InternalTestScriptDSL.g:176:1: entryRuleImport returns [EObject current=null] : iv_ruleImport= ruleImport EOF ;
    public final EObject entryRuleImport() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleImport = null;


        try {
            // InternalTestScriptDSL.g:176:47: (iv_ruleImport= ruleImport EOF )
            // InternalTestScriptDSL.g:177:2: iv_ruleImport= ruleImport EOF
            {
             newCompositeNode(grammarAccess.getImportRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleImport=ruleImport();

            state._fsp--;

             current =iv_ruleImport; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalTestScriptDSL.g:183:1: ruleImport returns [EObject current=null] : (otherlv_0= 'import' ( (lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard ) ) ) ;
    public final EObject ruleImport() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        AntlrDatatypeRuleToken lv_importedNamespace_1_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:189:2: ( (otherlv_0= 'import' ( (lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard ) ) ) )
            // InternalTestScriptDSL.g:190:2: (otherlv_0= 'import' ( (lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard ) ) )
            {
            // InternalTestScriptDSL.g:190:2: (otherlv_0= 'import' ( (lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard ) ) )
            // InternalTestScriptDSL.g:191:3: otherlv_0= 'import' ( (lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard ) )
            {
            otherlv_0=(Token)match(input,12,FOLLOW_5); 

            			newLeafNode(otherlv_0, grammarAccess.getImportAccess().getImportKeyword_0());
            		
            // InternalTestScriptDSL.g:195:3: ( (lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard ) )
            // InternalTestScriptDSL.g:196:4: (lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard )
            {
            // InternalTestScriptDSL.g:196:4: (lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard )
            // InternalTestScriptDSL.g:197:5: lv_importedNamespace_1_0= ruleQualifiedNameWithWildcard
            {

            					newCompositeNode(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_2);
            lv_importedNamespace_1_0=ruleQualifiedNameWithWildcard();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getImportRule());
            					}
            					set(
            						current,
            						"importedNamespace",
            						lv_importedNamespace_1_0,
            						"org.TestScriptDSL.QualifiedNameWithWildcard");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRuleQualifiedNameWithWildcard"
    // InternalTestScriptDSL.g:218:1: entryRuleQualifiedNameWithWildcard returns [String current=null] : iv_ruleQualifiedNameWithWildcard= ruleQualifiedNameWithWildcard EOF ;
    public final String entryRuleQualifiedNameWithWildcard() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleQualifiedNameWithWildcard = null;


        try {
            // InternalTestScriptDSL.g:218:65: (iv_ruleQualifiedNameWithWildcard= ruleQualifiedNameWithWildcard EOF )
            // InternalTestScriptDSL.g:219:2: iv_ruleQualifiedNameWithWildcard= ruleQualifiedNameWithWildcard EOF
            {
             newCompositeNode(grammarAccess.getQualifiedNameWithWildcardRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleQualifiedNameWithWildcard=ruleQualifiedNameWithWildcard();

            state._fsp--;

             current =iv_ruleQualifiedNameWithWildcard.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleQualifiedNameWithWildcard"


    // $ANTLR start "ruleQualifiedNameWithWildcard"
    // InternalTestScriptDSL.g:225:1: ruleQualifiedNameWithWildcard returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_QualifiedName_0= ruleQualifiedName (kw= '.*' )? ) ;
    public final AntlrDatatypeRuleToken ruleQualifiedNameWithWildcard() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_QualifiedName_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:231:2: ( (this_QualifiedName_0= ruleQualifiedName (kw= '.*' )? ) )
            // InternalTestScriptDSL.g:232:2: (this_QualifiedName_0= ruleQualifiedName (kw= '.*' )? )
            {
            // InternalTestScriptDSL.g:232:2: (this_QualifiedName_0= ruleQualifiedName (kw= '.*' )? )
            // InternalTestScriptDSL.g:233:3: this_QualifiedName_0= ruleQualifiedName (kw= '.*' )?
            {

            			newCompositeNode(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0());
            		
            pushFollow(FOLLOW_6);
            this_QualifiedName_0=ruleQualifiedName();

            state._fsp--;


            			current.merge(this_QualifiedName_0);
            		

            			afterParserOrEnumRuleCall();
            		
            // InternalTestScriptDSL.g:243:3: (kw= '.*' )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==13) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // InternalTestScriptDSL.g:244:4: kw= '.*'
                    {
                    kw=(Token)match(input,13,FOLLOW_2); 

                    				current.merge(kw);
                    				newLeafNode(kw, grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopAsteriskKeyword_1());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleQualifiedNameWithWildcard"


    // $ANTLR start "entryRuleQualifiedIndex"
    // InternalTestScriptDSL.g:254:1: entryRuleQualifiedIndex returns [String current=null] : iv_ruleQualifiedIndex= ruleQualifiedIndex EOF ;
    public final String entryRuleQualifiedIndex() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleQualifiedIndex = null;


        try {
            // InternalTestScriptDSL.g:254:54: (iv_ruleQualifiedIndex= ruleQualifiedIndex EOF )
            // InternalTestScriptDSL.g:255:2: iv_ruleQualifiedIndex= ruleQualifiedIndex EOF
            {
             newCompositeNode(grammarAccess.getQualifiedIndexRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleQualifiedIndex=ruleQualifiedIndex();

            state._fsp--;

             current =iv_ruleQualifiedIndex.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleQualifiedIndex"


    // $ANTLR start "ruleQualifiedIndex"
    // InternalTestScriptDSL.g:261:1: ruleQualifiedIndex returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_INT_0= RULE_INT | this_STRING_1= RULE_STRING ) ;
    public final AntlrDatatypeRuleToken ruleQualifiedIndex() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;
        Token this_STRING_1=null;


        	enterRule();

        try {
            // InternalTestScriptDSL.g:267:2: ( (this_INT_0= RULE_INT | this_STRING_1= RULE_STRING ) )
            // InternalTestScriptDSL.g:268:2: (this_INT_0= RULE_INT | this_STRING_1= RULE_STRING )
            {
            // InternalTestScriptDSL.g:268:2: (this_INT_0= RULE_INT | this_STRING_1= RULE_STRING )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==RULE_INT) ) {
                alt4=1;
            }
            else if ( (LA4_0==RULE_STRING) ) {
                alt4=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // InternalTestScriptDSL.g:269:3: this_INT_0= RULE_INT
                    {
                    this_INT_0=(Token)match(input,RULE_INT,FOLLOW_2); 

                    			current.merge(this_INT_0);
                    		

                    			newLeafNode(this_INT_0, grammarAccess.getQualifiedIndexAccess().getINTTerminalRuleCall_0());
                    		

                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:277:3: this_STRING_1= RULE_STRING
                    {
                    this_STRING_1=(Token)match(input,RULE_STRING,FOLLOW_2); 

                    			current.merge(this_STRING_1);
                    		

                    			newLeafNode(this_STRING_1, grammarAccess.getQualifiedIndexAccess().getSTRINGTerminalRuleCall_1());
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleQualifiedIndex"


    // $ANTLR start "entryRuleQualifiedValue"
    // InternalTestScriptDSL.g:288:1: entryRuleQualifiedValue returns [String current=null] : iv_ruleQualifiedValue= ruleQualifiedValue EOF ;
    public final String entryRuleQualifiedValue() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleQualifiedValue = null;


        try {
            // InternalTestScriptDSL.g:288:54: (iv_ruleQualifiedValue= ruleQualifiedValue EOF )
            // InternalTestScriptDSL.g:289:2: iv_ruleQualifiedValue= ruleQualifiedValue EOF
            {
             newCompositeNode(grammarAccess.getQualifiedValueRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleQualifiedValue=ruleQualifiedValue();

            state._fsp--;

             current =iv_ruleQualifiedValue.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleQualifiedValue"


    // $ANTLR start "ruleQualifiedValue"
    // InternalTestScriptDSL.g:295:1: ruleQualifiedValue returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_STRING_0= RULE_STRING | kw= 'True' | kw= 'False' | this_INT_3= RULE_INT | kw= '{}' ) ;
    public final AntlrDatatypeRuleToken ruleQualifiedValue() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_STRING_0=null;
        Token kw=null;
        Token this_INT_3=null;


        	enterRule();

        try {
            // InternalTestScriptDSL.g:301:2: ( (this_STRING_0= RULE_STRING | kw= 'True' | kw= 'False' | this_INT_3= RULE_INT | kw= '{}' ) )
            // InternalTestScriptDSL.g:302:2: (this_STRING_0= RULE_STRING | kw= 'True' | kw= 'False' | this_INT_3= RULE_INT | kw= '{}' )
            {
            // InternalTestScriptDSL.g:302:2: (this_STRING_0= RULE_STRING | kw= 'True' | kw= 'False' | this_INT_3= RULE_INT | kw= '{}' )
            int alt5=5;
            switch ( input.LA(1) ) {
            case RULE_STRING:
                {
                alt5=1;
                }
                break;
            case 14:
                {
                alt5=2;
                }
                break;
            case 15:
                {
                alt5=3;
                }
                break;
            case RULE_INT:
                {
                alt5=4;
                }
                break;
            case 16:
                {
                alt5=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // InternalTestScriptDSL.g:303:3: this_STRING_0= RULE_STRING
                    {
                    this_STRING_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

                    			current.merge(this_STRING_0);
                    		

                    			newLeafNode(this_STRING_0, grammarAccess.getQualifiedValueAccess().getSTRINGTerminalRuleCall_0());
                    		

                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:311:3: kw= 'True'
                    {
                    kw=(Token)match(input,14,FOLLOW_2); 

                    			current.merge(kw);
                    			newLeafNode(kw, grammarAccess.getQualifiedValueAccess().getTrueKeyword_1());
                    		

                    }
                    break;
                case 3 :
                    // InternalTestScriptDSL.g:317:3: kw= 'False'
                    {
                    kw=(Token)match(input,15,FOLLOW_2); 

                    			current.merge(kw);
                    			newLeafNode(kw, grammarAccess.getQualifiedValueAccess().getFalseKeyword_2());
                    		

                    }
                    break;
                case 4 :
                    // InternalTestScriptDSL.g:323:3: this_INT_3= RULE_INT
                    {
                    this_INT_3=(Token)match(input,RULE_INT,FOLLOW_2); 

                    			current.merge(this_INT_3);
                    		

                    			newLeafNode(this_INT_3, grammarAccess.getQualifiedValueAccess().getINTTerminalRuleCall_3());
                    		

                    }
                    break;
                case 5 :
                    // InternalTestScriptDSL.g:331:3: kw= '{}'
                    {
                    kw=(Token)match(input,16,FOLLOW_2); 

                    			current.merge(kw);
                    			newLeafNode(kw, grammarAccess.getQualifiedValueAccess().getLeftCurlyBracketRightCurlyBracketKeyword_4());
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleQualifiedValue"


    // $ANTLR start "entryRuleStmt"
    // InternalTestScriptDSL.g:340:1: entryRuleStmt returns [EObject current=null] : iv_ruleStmt= ruleStmt EOF ;
    public final EObject entryRuleStmt() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleStmt = null;


        try {
            // InternalTestScriptDSL.g:340:45: (iv_ruleStmt= ruleStmt EOF )
            // InternalTestScriptDSL.g:341:2: iv_ruleStmt= ruleStmt EOF
            {
             newCompositeNode(grammarAccess.getStmtRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleStmt=ruleStmt();

            state._fsp--;

             current =iv_ruleStmt; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleStmt"


    // $ANTLR start "ruleStmt"
    // InternalTestScriptDSL.g:347:1: ruleStmt returns [EObject current=null] : ( ( (lv_type_0_1= ruleExp | lv_type_0_2= ruleImport ) ) ) ;
    public final EObject ruleStmt() throws RecognitionException {
        EObject current = null;

        EObject lv_type_0_1 = null;

        EObject lv_type_0_2 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:353:2: ( ( ( (lv_type_0_1= ruleExp | lv_type_0_2= ruleImport ) ) ) )
            // InternalTestScriptDSL.g:354:2: ( ( (lv_type_0_1= ruleExp | lv_type_0_2= ruleImport ) ) )
            {
            // InternalTestScriptDSL.g:354:2: ( ( (lv_type_0_1= ruleExp | lv_type_0_2= ruleImport ) ) )
            // InternalTestScriptDSL.g:355:3: ( (lv_type_0_1= ruleExp | lv_type_0_2= ruleImport ) )
            {
            // InternalTestScriptDSL.g:355:3: ( (lv_type_0_1= ruleExp | lv_type_0_2= ruleImport ) )
            // InternalTestScriptDSL.g:356:4: (lv_type_0_1= ruleExp | lv_type_0_2= ruleImport )
            {
            // InternalTestScriptDSL.g:356:4: (lv_type_0_1= ruleExp | lv_type_0_2= ruleImport )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( ((LA6_0>=RULE_ID && LA6_0<=RULE_STRING)||(LA6_0>=14 && LA6_0<=16)||LA6_0==19) ) {
                alt6=1;
            }
            else if ( (LA6_0==12) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // InternalTestScriptDSL.g:357:5: lv_type_0_1= ruleExp
                    {

                    					newCompositeNode(grammarAccess.getStmtAccess().getTypeExpParserRuleCall_0_0());
                    				
                    pushFollow(FOLLOW_2);
                    lv_type_0_1=ruleExp();

                    state._fsp--;


                    					if (current==null) {
                    						current = createModelElementForParent(grammarAccess.getStmtRule());
                    					}
                    					set(
                    						current,
                    						"type",
                    						lv_type_0_1,
                    						"org.TestScriptDSL.Exp");
                    					afterParserOrEnumRuleCall();
                    				

                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:373:5: lv_type_0_2= ruleImport
                    {

                    					newCompositeNode(grammarAccess.getStmtAccess().getTypeImportParserRuleCall_0_1());
                    				
                    pushFollow(FOLLOW_2);
                    lv_type_0_2=ruleImport();

                    state._fsp--;


                    					if (current==null) {
                    						current = createModelElementForParent(grammarAccess.getStmtRule());
                    					}
                    					set(
                    						current,
                    						"type",
                    						lv_type_0_2,
                    						"org.TestScriptDSL.Import");
                    					afterParserOrEnumRuleCall();
                    				

                    }
                    break;

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStmt"


    // $ANTLR start "entryRuleExp"
    // InternalTestScriptDSL.g:394:1: entryRuleExp returns [EObject current=null] : iv_ruleExp= ruleExp EOF ;
    public final EObject entryRuleExp() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleExp = null;


        try {
            // InternalTestScriptDSL.g:394:44: (iv_ruleExp= ruleExp EOF )
            // InternalTestScriptDSL.g:395:2: iv_ruleExp= ruleExp EOF
            {
             newCompositeNode(grammarAccess.getExpRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleExp=ruleExp();

            state._fsp--;

             current =iv_ruleExp; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleExp"


    // $ANTLR start "ruleExp"
    // InternalTestScriptDSL.g:401:1: ruleExp returns [EObject current=null] : ( (lv_left_0_0= ruleEqual ) ) ;
    public final EObject ruleExp() throws RecognitionException {
        EObject current = null;

        EObject lv_left_0_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:407:2: ( ( (lv_left_0_0= ruleEqual ) ) )
            // InternalTestScriptDSL.g:408:2: ( (lv_left_0_0= ruleEqual ) )
            {
            // InternalTestScriptDSL.g:408:2: ( (lv_left_0_0= ruleEqual ) )
            // InternalTestScriptDSL.g:409:3: (lv_left_0_0= ruleEqual )
            {
            // InternalTestScriptDSL.g:409:3: (lv_left_0_0= ruleEqual )
            // InternalTestScriptDSL.g:410:4: lv_left_0_0= ruleEqual
            {

            				newCompositeNode(grammarAccess.getExpAccess().getLeftEqualParserRuleCall_0());
            			
            pushFollow(FOLLOW_2);
            lv_left_0_0=ruleEqual();

            state._fsp--;


            				if (current==null) {
            					current = createModelElementForParent(grammarAccess.getExpRule());
            				}
            				set(
            					current,
            					"left",
            					lv_left_0_0,
            					"org.TestScriptDSL.Equal");
            				afterParserOrEnumRuleCall();
            			

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleExp"


    // $ANTLR start "entryRuleVar"
    // InternalTestScriptDSL.g:430:1: entryRuleVar returns [EObject current=null] : iv_ruleVar= ruleVar EOF ;
    public final EObject entryRuleVar() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleVar = null;


        try {
            // InternalTestScriptDSL.g:430:44: (iv_ruleVar= ruleVar EOF )
            // InternalTestScriptDSL.g:431:2: iv_ruleVar= ruleVar EOF
            {
             newCompositeNode(grammarAccess.getVarRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleVar=ruleVar();

            state._fsp--;

             current =iv_ruleVar; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleVar"


    // $ANTLR start "ruleVar"
    // InternalTestScriptDSL.g:437:1: ruleVar returns [EObject current=null] : ( (lv_name_0_0= RULE_ID ) ) ;
    public final EObject ruleVar() throws RecognitionException {
        EObject current = null;

        Token lv_name_0_0=null;


        	enterRule();

        try {
            // InternalTestScriptDSL.g:443:2: ( ( (lv_name_0_0= RULE_ID ) ) )
            // InternalTestScriptDSL.g:444:2: ( (lv_name_0_0= RULE_ID ) )
            {
            // InternalTestScriptDSL.g:444:2: ( (lv_name_0_0= RULE_ID ) )
            // InternalTestScriptDSL.g:445:3: (lv_name_0_0= RULE_ID )
            {
            // InternalTestScriptDSL.g:445:3: (lv_name_0_0= RULE_ID )
            // InternalTestScriptDSL.g:446:4: lv_name_0_0= RULE_ID
            {
            lv_name_0_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            				newLeafNode(lv_name_0_0, grammarAccess.getVarAccess().getNameIDTerminalRuleCall_0());
            			

            				if (current==null) {
            					current = createModelElement(grammarAccess.getVarRule());
            				}
            				setWithLastConsumed(
            					current,
            					"name",
            					lv_name_0_0,
            					"org.eclipse.xtext.common.Terminals.ID");
            			

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleVar"


    // $ANTLR start "entryRuleVal"
    // InternalTestScriptDSL.g:465:1: entryRuleVal returns [EObject current=null] : iv_ruleVal= ruleVal EOF ;
    public final EObject entryRuleVal() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleVal = null;


        try {
            // InternalTestScriptDSL.g:465:44: (iv_ruleVal= ruleVal EOF )
            // InternalTestScriptDSL.g:466:2: iv_ruleVal= ruleVal EOF
            {
             newCompositeNode(grammarAccess.getValRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleVal=ruleVal();

            state._fsp--;

             current =iv_ruleVal; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleVal"


    // $ANTLR start "ruleVal"
    // InternalTestScriptDSL.g:472:1: ruleVal returns [EObject current=null] : ( (lv_name_0_0= ruleQualifiedValue ) ) ;
    public final EObject ruleVal() throws RecognitionException {
        EObject current = null;

        AntlrDatatypeRuleToken lv_name_0_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:478:2: ( ( (lv_name_0_0= ruleQualifiedValue ) ) )
            // InternalTestScriptDSL.g:479:2: ( (lv_name_0_0= ruleQualifiedValue ) )
            {
            // InternalTestScriptDSL.g:479:2: ( (lv_name_0_0= ruleQualifiedValue ) )
            // InternalTestScriptDSL.g:480:3: (lv_name_0_0= ruleQualifiedValue )
            {
            // InternalTestScriptDSL.g:480:3: (lv_name_0_0= ruleQualifiedValue )
            // InternalTestScriptDSL.g:481:4: lv_name_0_0= ruleQualifiedValue
            {

            				newCompositeNode(grammarAccess.getValAccess().getNameQualifiedValueParserRuleCall_0());
            			
            pushFollow(FOLLOW_2);
            lv_name_0_0=ruleQualifiedValue();

            state._fsp--;


            				if (current==null) {
            					current = createModelElementForParent(grammarAccess.getValRule());
            				}
            				set(
            					current,
            					"name",
            					lv_name_0_0,
            					"org.TestScriptDSL.QualifiedValue");
            				afterParserOrEnumRuleCall();
            			

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleVal"


    // $ANTLR start "entryRuleDot"
    // InternalTestScriptDSL.g:501:1: entryRuleDot returns [EObject current=null] : iv_ruleDot= ruleDot EOF ;
    public final EObject entryRuleDot() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDot = null;


        try {
            // InternalTestScriptDSL.g:501:44: (iv_ruleDot= ruleDot EOF )
            // InternalTestScriptDSL.g:502:2: iv_ruleDot= ruleDot EOF
            {
             newCompositeNode(grammarAccess.getDotRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDot=ruleDot();

            state._fsp--;

             current =iv_ruleDot; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDot"


    // $ANTLR start "ruleDot"
    // InternalTestScriptDSL.g:508:1: ruleDot returns [EObject current=null] : ( ( (lv_left_0_0= ruleArray ) ) ( () ( (lv_op_2_0= '.' ) ) ( (lv_right_3_0= ruleArray ) ) )* ) ;
    public final EObject ruleDot() throws RecognitionException {
        EObject current = null;

        Token lv_op_2_0=null;
        EObject lv_left_0_0 = null;

        EObject lv_right_3_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:514:2: ( ( ( (lv_left_0_0= ruleArray ) ) ( () ( (lv_op_2_0= '.' ) ) ( (lv_right_3_0= ruleArray ) ) )* ) )
            // InternalTestScriptDSL.g:515:2: ( ( (lv_left_0_0= ruleArray ) ) ( () ( (lv_op_2_0= '.' ) ) ( (lv_right_3_0= ruleArray ) ) )* )
            {
            // InternalTestScriptDSL.g:515:2: ( ( (lv_left_0_0= ruleArray ) ) ( () ( (lv_op_2_0= '.' ) ) ( (lv_right_3_0= ruleArray ) ) )* )
            // InternalTestScriptDSL.g:516:3: ( (lv_left_0_0= ruleArray ) ) ( () ( (lv_op_2_0= '.' ) ) ( (lv_right_3_0= ruleArray ) ) )*
            {
            // InternalTestScriptDSL.g:516:3: ( (lv_left_0_0= ruleArray ) )
            // InternalTestScriptDSL.g:517:4: (lv_left_0_0= ruleArray )
            {
            // InternalTestScriptDSL.g:517:4: (lv_left_0_0= ruleArray )
            // InternalTestScriptDSL.g:518:5: lv_left_0_0= ruleArray
            {

            					newCompositeNode(grammarAccess.getDotAccess().getLeftArrayParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_4);
            lv_left_0_0=ruleArray();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getDotRule());
            					}
            					set(
            						current,
            						"left",
            						lv_left_0_0,
            						"org.TestScriptDSL.Array");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalTestScriptDSL.g:535:3: ( () ( (lv_op_2_0= '.' ) ) ( (lv_right_3_0= ruleArray ) ) )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==11) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // InternalTestScriptDSL.g:536:4: () ( (lv_op_2_0= '.' ) ) ( (lv_right_3_0= ruleArray ) )
            	    {
            	    // InternalTestScriptDSL.g:536:4: ()
            	    // InternalTestScriptDSL.g:537:5: 
            	    {

            	    					current = forceCreateModelElementAndSet(
            	    						grammarAccess.getDotAccess().getDotLeftAction_1_0(),
            	    						current);
            	    				

            	    }

            	    // InternalTestScriptDSL.g:543:4: ( (lv_op_2_0= '.' ) )
            	    // InternalTestScriptDSL.g:544:5: (lv_op_2_0= '.' )
            	    {
            	    // InternalTestScriptDSL.g:544:5: (lv_op_2_0= '.' )
            	    // InternalTestScriptDSL.g:545:6: lv_op_2_0= '.'
            	    {
            	    lv_op_2_0=(Token)match(input,11,FOLLOW_7); 

            	    						newLeafNode(lv_op_2_0, grammarAccess.getDotAccess().getOpFullStopKeyword_1_1_0());
            	    					

            	    						if (current==null) {
            	    							current = createModelElement(grammarAccess.getDotRule());
            	    						}
            	    						setWithLastConsumed(current, "op", lv_op_2_0, ".");
            	    					

            	    }


            	    }

            	    // InternalTestScriptDSL.g:557:4: ( (lv_right_3_0= ruleArray ) )
            	    // InternalTestScriptDSL.g:558:5: (lv_right_3_0= ruleArray )
            	    {
            	    // InternalTestScriptDSL.g:558:5: (lv_right_3_0= ruleArray )
            	    // InternalTestScriptDSL.g:559:6: lv_right_3_0= ruleArray
            	    {

            	    						newCompositeNode(grammarAccess.getDotAccess().getRightArrayParserRuleCall_1_2_0());
            	    					
            	    pushFollow(FOLLOW_4);
            	    lv_right_3_0=ruleArray();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getDotRule());
            	    						}
            	    						set(
            	    							current,
            	    							"right",
            	    							lv_right_3_0,
            	    							"org.TestScriptDSL.Array");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDot"


    // $ANTLR start "entryRuleArray"
    // InternalTestScriptDSL.g:581:1: entryRuleArray returns [EObject current=null] : iv_ruleArray= ruleArray EOF ;
    public final EObject entryRuleArray() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleArray = null;


        try {
            // InternalTestScriptDSL.g:581:46: (iv_ruleArray= ruleArray EOF )
            // InternalTestScriptDSL.g:582:2: iv_ruleArray= ruleArray EOF
            {
             newCompositeNode(grammarAccess.getArrayRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleArray=ruleArray();

            state._fsp--;

             current =iv_ruleArray; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleArray"


    // $ANTLR start "ruleArray"
    // InternalTestScriptDSL.g:588:1: ruleArray returns [EObject current=null] : ( ( (lv_left_0_0= rulePrimary ) ) ( () ( (lv_op_2_0= '[' ) ) ( (lv_right_3_0= rulePrimary ) ) otherlv_4= ']' )* ) ;
    public final EObject ruleArray() throws RecognitionException {
        EObject current = null;

        Token lv_op_2_0=null;
        Token otherlv_4=null;
        EObject lv_left_0_0 = null;

        EObject lv_right_3_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:594:2: ( ( ( (lv_left_0_0= rulePrimary ) ) ( () ( (lv_op_2_0= '[' ) ) ( (lv_right_3_0= rulePrimary ) ) otherlv_4= ']' )* ) )
            // InternalTestScriptDSL.g:595:2: ( ( (lv_left_0_0= rulePrimary ) ) ( () ( (lv_op_2_0= '[' ) ) ( (lv_right_3_0= rulePrimary ) ) otherlv_4= ']' )* )
            {
            // InternalTestScriptDSL.g:595:2: ( ( (lv_left_0_0= rulePrimary ) ) ( () ( (lv_op_2_0= '[' ) ) ( (lv_right_3_0= rulePrimary ) ) otherlv_4= ']' )* )
            // InternalTestScriptDSL.g:596:3: ( (lv_left_0_0= rulePrimary ) ) ( () ( (lv_op_2_0= '[' ) ) ( (lv_right_3_0= rulePrimary ) ) otherlv_4= ']' )*
            {
            // InternalTestScriptDSL.g:596:3: ( (lv_left_0_0= rulePrimary ) )
            // InternalTestScriptDSL.g:597:4: (lv_left_0_0= rulePrimary )
            {
            // InternalTestScriptDSL.g:597:4: (lv_left_0_0= rulePrimary )
            // InternalTestScriptDSL.g:598:5: lv_left_0_0= rulePrimary
            {

            					newCompositeNode(grammarAccess.getArrayAccess().getLeftPrimaryParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_8);
            lv_left_0_0=rulePrimary();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getArrayRule());
            					}
            					set(
            						current,
            						"left",
            						lv_left_0_0,
            						"org.TestScriptDSL.Primary");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalTestScriptDSL.g:615:3: ( () ( (lv_op_2_0= '[' ) ) ( (lv_right_3_0= rulePrimary ) ) otherlv_4= ']' )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==17) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // InternalTestScriptDSL.g:616:4: () ( (lv_op_2_0= '[' ) ) ( (lv_right_3_0= rulePrimary ) ) otherlv_4= ']'
            	    {
            	    // InternalTestScriptDSL.g:616:4: ()
            	    // InternalTestScriptDSL.g:617:5: 
            	    {

            	    					current = forceCreateModelElementAndSet(
            	    						grammarAccess.getArrayAccess().getArrayLeftAction_1_0(),
            	    						current);
            	    				

            	    }

            	    // InternalTestScriptDSL.g:623:4: ( (lv_op_2_0= '[' ) )
            	    // InternalTestScriptDSL.g:624:5: (lv_op_2_0= '[' )
            	    {
            	    // InternalTestScriptDSL.g:624:5: (lv_op_2_0= '[' )
            	    // InternalTestScriptDSL.g:625:6: lv_op_2_0= '['
            	    {
            	    lv_op_2_0=(Token)match(input,17,FOLLOW_7); 

            	    						newLeafNode(lv_op_2_0, grammarAccess.getArrayAccess().getOpLeftSquareBracketKeyword_1_1_0());
            	    					

            	    						if (current==null) {
            	    							current = createModelElement(grammarAccess.getArrayRule());
            	    						}
            	    						setWithLastConsumed(current, "op", lv_op_2_0, "[");
            	    					

            	    }


            	    }

            	    // InternalTestScriptDSL.g:637:4: ( (lv_right_3_0= rulePrimary ) )
            	    // InternalTestScriptDSL.g:638:5: (lv_right_3_0= rulePrimary )
            	    {
            	    // InternalTestScriptDSL.g:638:5: (lv_right_3_0= rulePrimary )
            	    // InternalTestScriptDSL.g:639:6: lv_right_3_0= rulePrimary
            	    {

            	    						newCompositeNode(grammarAccess.getArrayAccess().getRightPrimaryParserRuleCall_1_2_0());
            	    					
            	    pushFollow(FOLLOW_9);
            	    lv_right_3_0=rulePrimary();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getArrayRule());
            	    						}
            	    						set(
            	    							current,
            	    							"right",
            	    							lv_right_3_0,
            	    							"org.TestScriptDSL.Primary");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }

            	    otherlv_4=(Token)match(input,18,FOLLOW_8); 

            	    				newLeafNode(otherlv_4, grammarAccess.getArrayAccess().getRightSquareBracketKeyword_1_3());
            	    			

            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleArray"


    // $ANTLR start "entryRulePrimary"
    // InternalTestScriptDSL.g:665:1: entryRulePrimary returns [EObject current=null] : iv_rulePrimary= rulePrimary EOF ;
    public final EObject entryRulePrimary() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePrimary = null;


        try {
            // InternalTestScriptDSL.g:665:48: (iv_rulePrimary= rulePrimary EOF )
            // InternalTestScriptDSL.g:666:2: iv_rulePrimary= rulePrimary EOF
            {
             newCompositeNode(grammarAccess.getPrimaryRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePrimary=rulePrimary();

            state._fsp--;

             current =iv_rulePrimary; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePrimary"


    // $ANTLR start "rulePrimary"
    // InternalTestScriptDSL.g:672:1: rulePrimary returns [EObject current=null] : ( ( ( (lv_op_0_0= '(' ) ) ( (lv_left_1_0= ruleEqual ) ) otherlv_2= ')' ) | ( (lv_left_3_0= ruleVar ) ) | ( (lv_left_4_0= ruleVal ) ) ) ;
    public final EObject rulePrimary() throws RecognitionException {
        EObject current = null;

        Token lv_op_0_0=null;
        Token otherlv_2=null;
        EObject lv_left_1_0 = null;

        EObject lv_left_3_0 = null;

        EObject lv_left_4_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:678:2: ( ( ( ( (lv_op_0_0= '(' ) ) ( (lv_left_1_0= ruleEqual ) ) otherlv_2= ')' ) | ( (lv_left_3_0= ruleVar ) ) | ( (lv_left_4_0= ruleVal ) ) ) )
            // InternalTestScriptDSL.g:679:2: ( ( ( (lv_op_0_0= '(' ) ) ( (lv_left_1_0= ruleEqual ) ) otherlv_2= ')' ) | ( (lv_left_3_0= ruleVar ) ) | ( (lv_left_4_0= ruleVal ) ) )
            {
            // InternalTestScriptDSL.g:679:2: ( ( ( (lv_op_0_0= '(' ) ) ( (lv_left_1_0= ruleEqual ) ) otherlv_2= ')' ) | ( (lv_left_3_0= ruleVar ) ) | ( (lv_left_4_0= ruleVal ) ) )
            int alt9=3;
            switch ( input.LA(1) ) {
            case 19:
                {
                alt9=1;
                }
                break;
            case RULE_ID:
                {
                alt9=2;
                }
                break;
            case RULE_INT:
            case RULE_STRING:
            case 14:
            case 15:
            case 16:
                {
                alt9=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // InternalTestScriptDSL.g:680:3: ( ( (lv_op_0_0= '(' ) ) ( (lv_left_1_0= ruleEqual ) ) otherlv_2= ')' )
                    {
                    // InternalTestScriptDSL.g:680:3: ( ( (lv_op_0_0= '(' ) ) ( (lv_left_1_0= ruleEqual ) ) otherlv_2= ')' )
                    // InternalTestScriptDSL.g:681:4: ( (lv_op_0_0= '(' ) ) ( (lv_left_1_0= ruleEqual ) ) otherlv_2= ')'
                    {
                    // InternalTestScriptDSL.g:681:4: ( (lv_op_0_0= '(' ) )
                    // InternalTestScriptDSL.g:682:5: (lv_op_0_0= '(' )
                    {
                    // InternalTestScriptDSL.g:682:5: (lv_op_0_0= '(' )
                    // InternalTestScriptDSL.g:683:6: lv_op_0_0= '('
                    {
                    lv_op_0_0=(Token)match(input,19,FOLLOW_7); 

                    						newLeafNode(lv_op_0_0, grammarAccess.getPrimaryAccess().getOpLeftParenthesisKeyword_0_0_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getPrimaryRule());
                    						}
                    						setWithLastConsumed(current, "op", lv_op_0_0, "(");
                    					

                    }


                    }

                    // InternalTestScriptDSL.g:695:4: ( (lv_left_1_0= ruleEqual ) )
                    // InternalTestScriptDSL.g:696:5: (lv_left_1_0= ruleEqual )
                    {
                    // InternalTestScriptDSL.g:696:5: (lv_left_1_0= ruleEqual )
                    // InternalTestScriptDSL.g:697:6: lv_left_1_0= ruleEqual
                    {

                    						newCompositeNode(grammarAccess.getPrimaryAccess().getLeftEqualParserRuleCall_0_1_0());
                    					
                    pushFollow(FOLLOW_10);
                    lv_left_1_0=ruleEqual();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getPrimaryRule());
                    						}
                    						set(
                    							current,
                    							"left",
                    							lv_left_1_0,
                    							"org.TestScriptDSL.Equal");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    otherlv_2=(Token)match(input,20,FOLLOW_2); 

                    				newLeafNode(otherlv_2, grammarAccess.getPrimaryAccess().getRightParenthesisKeyword_0_2());
                    			

                    }


                    }
                    break;
                case 2 :
                    // InternalTestScriptDSL.g:720:3: ( (lv_left_3_0= ruleVar ) )
                    {
                    // InternalTestScriptDSL.g:720:3: ( (lv_left_3_0= ruleVar ) )
                    // InternalTestScriptDSL.g:721:4: (lv_left_3_0= ruleVar )
                    {
                    // InternalTestScriptDSL.g:721:4: (lv_left_3_0= ruleVar )
                    // InternalTestScriptDSL.g:722:5: lv_left_3_0= ruleVar
                    {

                    					newCompositeNode(grammarAccess.getPrimaryAccess().getLeftVarParserRuleCall_1_0());
                    				
                    pushFollow(FOLLOW_2);
                    lv_left_3_0=ruleVar();

                    state._fsp--;


                    					if (current==null) {
                    						current = createModelElementForParent(grammarAccess.getPrimaryRule());
                    					}
                    					set(
                    						current,
                    						"left",
                    						lv_left_3_0,
                    						"org.TestScriptDSL.Var");
                    					afterParserOrEnumRuleCall();
                    				

                    }


                    }


                    }
                    break;
                case 3 :
                    // InternalTestScriptDSL.g:740:3: ( (lv_left_4_0= ruleVal ) )
                    {
                    // InternalTestScriptDSL.g:740:3: ( (lv_left_4_0= ruleVal ) )
                    // InternalTestScriptDSL.g:741:4: (lv_left_4_0= ruleVal )
                    {
                    // InternalTestScriptDSL.g:741:4: (lv_left_4_0= ruleVal )
                    // InternalTestScriptDSL.g:742:5: lv_left_4_0= ruleVal
                    {

                    					newCompositeNode(grammarAccess.getPrimaryAccess().getLeftValParserRuleCall_2_0());
                    				
                    pushFollow(FOLLOW_2);
                    lv_left_4_0=ruleVal();

                    state._fsp--;


                    					if (current==null) {
                    						current = createModelElementForParent(grammarAccess.getPrimaryRule());
                    					}
                    					set(
                    						current,
                    						"left",
                    						lv_left_4_0,
                    						"org.TestScriptDSL.Val");
                    					afterParserOrEnumRuleCall();
                    				

                    }


                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePrimary"


    // $ANTLR start "entryRuleEqual"
    // InternalTestScriptDSL.g:763:1: entryRuleEqual returns [EObject current=null] : iv_ruleEqual= ruleEqual EOF ;
    public final EObject entryRuleEqual() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEqual = null;


        try {
            // InternalTestScriptDSL.g:763:46: (iv_ruleEqual= ruleEqual EOF )
            // InternalTestScriptDSL.g:764:2: iv_ruleEqual= ruleEqual EOF
            {
             newCompositeNode(grammarAccess.getEqualRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEqual=ruleEqual();

            state._fsp--;

             current =iv_ruleEqual; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEqual"


    // $ANTLR start "ruleEqual"
    // InternalTestScriptDSL.g:770:1: ruleEqual returns [EObject current=null] : ( ( (lv_left_0_0= ruleAddAndSub ) ) ( () ( (lv_op_2_0= '=' ) ) ( (lv_right_3_0= ruleAddAndSub ) ) )* ) ;
    public final EObject ruleEqual() throws RecognitionException {
        EObject current = null;

        Token lv_op_2_0=null;
        EObject lv_left_0_0 = null;

        EObject lv_right_3_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:776:2: ( ( ( (lv_left_0_0= ruleAddAndSub ) ) ( () ( (lv_op_2_0= '=' ) ) ( (lv_right_3_0= ruleAddAndSub ) ) )* ) )
            // InternalTestScriptDSL.g:777:2: ( ( (lv_left_0_0= ruleAddAndSub ) ) ( () ( (lv_op_2_0= '=' ) ) ( (lv_right_3_0= ruleAddAndSub ) ) )* )
            {
            // InternalTestScriptDSL.g:777:2: ( ( (lv_left_0_0= ruleAddAndSub ) ) ( () ( (lv_op_2_0= '=' ) ) ( (lv_right_3_0= ruleAddAndSub ) ) )* )
            // InternalTestScriptDSL.g:778:3: ( (lv_left_0_0= ruleAddAndSub ) ) ( () ( (lv_op_2_0= '=' ) ) ( (lv_right_3_0= ruleAddAndSub ) ) )*
            {
            // InternalTestScriptDSL.g:778:3: ( (lv_left_0_0= ruleAddAndSub ) )
            // InternalTestScriptDSL.g:779:4: (lv_left_0_0= ruleAddAndSub )
            {
            // InternalTestScriptDSL.g:779:4: (lv_left_0_0= ruleAddAndSub )
            // InternalTestScriptDSL.g:780:5: lv_left_0_0= ruleAddAndSub
            {

            					newCompositeNode(grammarAccess.getEqualAccess().getLeftAddAndSubParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_11);
            lv_left_0_0=ruleAddAndSub();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getEqualRule());
            					}
            					set(
            						current,
            						"left",
            						lv_left_0_0,
            						"org.TestScriptDSL.AddAndSub");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalTestScriptDSL.g:797:3: ( () ( (lv_op_2_0= '=' ) ) ( (lv_right_3_0= ruleAddAndSub ) ) )*
            loop10:
            do {
                int alt10=2;
                int LA10_0 = input.LA(1);

                if ( (LA10_0==21) ) {
                    alt10=1;
                }


                switch (alt10) {
            	case 1 :
            	    // InternalTestScriptDSL.g:798:4: () ( (lv_op_2_0= '=' ) ) ( (lv_right_3_0= ruleAddAndSub ) )
            	    {
            	    // InternalTestScriptDSL.g:798:4: ()
            	    // InternalTestScriptDSL.g:799:5: 
            	    {

            	    					current = forceCreateModelElementAndSet(
            	    						grammarAccess.getEqualAccess().getEuqalLeftAction_1_0(),
            	    						current);
            	    				

            	    }

            	    // InternalTestScriptDSL.g:805:4: ( (lv_op_2_0= '=' ) )
            	    // InternalTestScriptDSL.g:806:5: (lv_op_2_0= '=' )
            	    {
            	    // InternalTestScriptDSL.g:806:5: (lv_op_2_0= '=' )
            	    // InternalTestScriptDSL.g:807:6: lv_op_2_0= '='
            	    {
            	    lv_op_2_0=(Token)match(input,21,FOLLOW_7); 

            	    						newLeafNode(lv_op_2_0, grammarAccess.getEqualAccess().getOpEqualsSignKeyword_1_1_0());
            	    					

            	    						if (current==null) {
            	    							current = createModelElement(grammarAccess.getEqualRule());
            	    						}
            	    						setWithLastConsumed(current, "op", lv_op_2_0, "=");
            	    					

            	    }


            	    }

            	    // InternalTestScriptDSL.g:819:4: ( (lv_right_3_0= ruleAddAndSub ) )
            	    // InternalTestScriptDSL.g:820:5: (lv_right_3_0= ruleAddAndSub )
            	    {
            	    // InternalTestScriptDSL.g:820:5: (lv_right_3_0= ruleAddAndSub )
            	    // InternalTestScriptDSL.g:821:6: lv_right_3_0= ruleAddAndSub
            	    {

            	    						newCompositeNode(grammarAccess.getEqualAccess().getRightAddAndSubParserRuleCall_1_2_0());
            	    					
            	    pushFollow(FOLLOW_11);
            	    lv_right_3_0=ruleAddAndSub();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getEqualRule());
            	    						}
            	    						set(
            	    							current,
            	    							"right",
            	    							lv_right_3_0,
            	    							"org.TestScriptDSL.AddAndSub");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEqual"


    // $ANTLR start "entryRuleAddAndSub"
    // InternalTestScriptDSL.g:843:1: entryRuleAddAndSub returns [EObject current=null] : iv_ruleAddAndSub= ruleAddAndSub EOF ;
    public final EObject entryRuleAddAndSub() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAddAndSub = null;


        try {
            // InternalTestScriptDSL.g:843:50: (iv_ruleAddAndSub= ruleAddAndSub EOF )
            // InternalTestScriptDSL.g:844:2: iv_ruleAddAndSub= ruleAddAndSub EOF
            {
             newCompositeNode(grammarAccess.getAddAndSubRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAddAndSub=ruleAddAndSub();

            state._fsp--;

             current =iv_ruleAddAndSub; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAddAndSub"


    // $ANTLR start "ruleAddAndSub"
    // InternalTestScriptDSL.g:850:1: ruleAddAndSub returns [EObject current=null] : ( ( (lv_left_0_0= ruleMulAndDiv ) ) ( () ( ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) ) ) ( (lv_right_3_0= ruleMulAndDiv ) ) )* ) ;
    public final EObject ruleAddAndSub() throws RecognitionException {
        EObject current = null;

        Token lv_op_2_1=null;
        Token lv_op_2_2=null;
        EObject lv_left_0_0 = null;

        EObject lv_right_3_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:856:2: ( ( ( (lv_left_0_0= ruleMulAndDiv ) ) ( () ( ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) ) ) ( (lv_right_3_0= ruleMulAndDiv ) ) )* ) )
            // InternalTestScriptDSL.g:857:2: ( ( (lv_left_0_0= ruleMulAndDiv ) ) ( () ( ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) ) ) ( (lv_right_3_0= ruleMulAndDiv ) ) )* )
            {
            // InternalTestScriptDSL.g:857:2: ( ( (lv_left_0_0= ruleMulAndDiv ) ) ( () ( ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) ) ) ( (lv_right_3_0= ruleMulAndDiv ) ) )* )
            // InternalTestScriptDSL.g:858:3: ( (lv_left_0_0= ruleMulAndDiv ) ) ( () ( ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) ) ) ( (lv_right_3_0= ruleMulAndDiv ) ) )*
            {
            // InternalTestScriptDSL.g:858:3: ( (lv_left_0_0= ruleMulAndDiv ) )
            // InternalTestScriptDSL.g:859:4: (lv_left_0_0= ruleMulAndDiv )
            {
            // InternalTestScriptDSL.g:859:4: (lv_left_0_0= ruleMulAndDiv )
            // InternalTestScriptDSL.g:860:5: lv_left_0_0= ruleMulAndDiv
            {

            					newCompositeNode(grammarAccess.getAddAndSubAccess().getLeftMulAndDivParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_12);
            lv_left_0_0=ruleMulAndDiv();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getAddAndSubRule());
            					}
            					set(
            						current,
            						"left",
            						lv_left_0_0,
            						"org.TestScriptDSL.MulAndDiv");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalTestScriptDSL.g:877:3: ( () ( ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) ) ) ( (lv_right_3_0= ruleMulAndDiv ) ) )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( ((LA12_0>=22 && LA12_0<=23)) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // InternalTestScriptDSL.g:878:4: () ( ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) ) ) ( (lv_right_3_0= ruleMulAndDiv ) )
            	    {
            	    // InternalTestScriptDSL.g:878:4: ()
            	    // InternalTestScriptDSL.g:879:5: 
            	    {

            	    					current = forceCreateModelElementAndSet(
            	    						grammarAccess.getAddAndSubAccess().getAddAndSubLeftAction_1_0(),
            	    						current);
            	    				

            	    }

            	    // InternalTestScriptDSL.g:885:4: ( ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) ) )
            	    // InternalTestScriptDSL.g:886:5: ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) )
            	    {
            	    // InternalTestScriptDSL.g:886:5: ( (lv_op_2_1= '+' | lv_op_2_2= '-' ) )
            	    // InternalTestScriptDSL.g:887:6: (lv_op_2_1= '+' | lv_op_2_2= '-' )
            	    {
            	    // InternalTestScriptDSL.g:887:6: (lv_op_2_1= '+' | lv_op_2_2= '-' )
            	    int alt11=2;
            	    int LA11_0 = input.LA(1);

            	    if ( (LA11_0==22) ) {
            	        alt11=1;
            	    }
            	    else if ( (LA11_0==23) ) {
            	        alt11=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 11, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt11) {
            	        case 1 :
            	            // InternalTestScriptDSL.g:888:7: lv_op_2_1= '+'
            	            {
            	            lv_op_2_1=(Token)match(input,22,FOLLOW_7); 

            	            							newLeafNode(lv_op_2_1, grammarAccess.getAddAndSubAccess().getOpPlusSignKeyword_1_1_0_0());
            	            						

            	            							if (current==null) {
            	            								current = createModelElement(grammarAccess.getAddAndSubRule());
            	            							}
            	            							setWithLastConsumed(current, "op", lv_op_2_1, null);
            	            						

            	            }
            	            break;
            	        case 2 :
            	            // InternalTestScriptDSL.g:899:7: lv_op_2_2= '-'
            	            {
            	            lv_op_2_2=(Token)match(input,23,FOLLOW_7); 

            	            							newLeafNode(lv_op_2_2, grammarAccess.getAddAndSubAccess().getOpHyphenMinusKeyword_1_1_0_1());
            	            						

            	            							if (current==null) {
            	            								current = createModelElement(grammarAccess.getAddAndSubRule());
            	            							}
            	            							setWithLastConsumed(current, "op", lv_op_2_2, null);
            	            						

            	            }
            	            break;

            	    }


            	    }


            	    }

            	    // InternalTestScriptDSL.g:912:4: ( (lv_right_3_0= ruleMulAndDiv ) )
            	    // InternalTestScriptDSL.g:913:5: (lv_right_3_0= ruleMulAndDiv )
            	    {
            	    // InternalTestScriptDSL.g:913:5: (lv_right_3_0= ruleMulAndDiv )
            	    // InternalTestScriptDSL.g:914:6: lv_right_3_0= ruleMulAndDiv
            	    {

            	    						newCompositeNode(grammarAccess.getAddAndSubAccess().getRightMulAndDivParserRuleCall_1_2_0());
            	    					
            	    pushFollow(FOLLOW_12);
            	    lv_right_3_0=ruleMulAndDiv();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getAddAndSubRule());
            	    						}
            	    						set(
            	    							current,
            	    							"right",
            	    							lv_right_3_0,
            	    							"org.TestScriptDSL.MulAndDiv");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAddAndSub"


    // $ANTLR start "entryRuleMulAndDiv"
    // InternalTestScriptDSL.g:936:1: entryRuleMulAndDiv returns [EObject current=null] : iv_ruleMulAndDiv= ruleMulAndDiv EOF ;
    public final EObject entryRuleMulAndDiv() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMulAndDiv = null;


        try {
            // InternalTestScriptDSL.g:936:50: (iv_ruleMulAndDiv= ruleMulAndDiv EOF )
            // InternalTestScriptDSL.g:937:2: iv_ruleMulAndDiv= ruleMulAndDiv EOF
            {
             newCompositeNode(grammarAccess.getMulAndDivRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMulAndDiv=ruleMulAndDiv();

            state._fsp--;

             current =iv_ruleMulAndDiv; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMulAndDiv"


    // $ANTLR start "ruleMulAndDiv"
    // InternalTestScriptDSL.g:943:1: ruleMulAndDiv returns [EObject current=null] : ( ( (lv_left_0_0= ruleDot ) ) ( () ( ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) ) ) ( (lv_right_3_0= ruleDot ) ) )* ) ;
    public final EObject ruleMulAndDiv() throws RecognitionException {
        EObject current = null;

        Token lv_op_2_1=null;
        Token lv_op_2_2=null;
        EObject lv_left_0_0 = null;

        EObject lv_right_3_0 = null;



        	enterRule();

        try {
            // InternalTestScriptDSL.g:949:2: ( ( ( (lv_left_0_0= ruleDot ) ) ( () ( ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) ) ) ( (lv_right_3_0= ruleDot ) ) )* ) )
            // InternalTestScriptDSL.g:950:2: ( ( (lv_left_0_0= ruleDot ) ) ( () ( ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) ) ) ( (lv_right_3_0= ruleDot ) ) )* )
            {
            // InternalTestScriptDSL.g:950:2: ( ( (lv_left_0_0= ruleDot ) ) ( () ( ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) ) ) ( (lv_right_3_0= ruleDot ) ) )* )
            // InternalTestScriptDSL.g:951:3: ( (lv_left_0_0= ruleDot ) ) ( () ( ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) ) ) ( (lv_right_3_0= ruleDot ) ) )*
            {
            // InternalTestScriptDSL.g:951:3: ( (lv_left_0_0= ruleDot ) )
            // InternalTestScriptDSL.g:952:4: (lv_left_0_0= ruleDot )
            {
            // InternalTestScriptDSL.g:952:4: (lv_left_0_0= ruleDot )
            // InternalTestScriptDSL.g:953:5: lv_left_0_0= ruleDot
            {

            					newCompositeNode(grammarAccess.getMulAndDivAccess().getLeftDotParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_13);
            lv_left_0_0=ruleDot();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getMulAndDivRule());
            					}
            					set(
            						current,
            						"left",
            						lv_left_0_0,
            						"org.TestScriptDSL.Dot");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalTestScriptDSL.g:970:3: ( () ( ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) ) ) ( (lv_right_3_0= ruleDot ) ) )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);

                if ( ((LA14_0>=24 && LA14_0<=25)) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // InternalTestScriptDSL.g:971:4: () ( ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) ) ) ( (lv_right_3_0= ruleDot ) )
            	    {
            	    // InternalTestScriptDSL.g:971:4: ()
            	    // InternalTestScriptDSL.g:972:5: 
            	    {

            	    					current = forceCreateModelElementAndSet(
            	    						grammarAccess.getMulAndDivAccess().getMulAndDivLeftAction_1_0(),
            	    						current);
            	    				

            	    }

            	    // InternalTestScriptDSL.g:978:4: ( ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) ) )
            	    // InternalTestScriptDSL.g:979:5: ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) )
            	    {
            	    // InternalTestScriptDSL.g:979:5: ( (lv_op_2_1= '*' | lv_op_2_2= '/' ) )
            	    // InternalTestScriptDSL.g:980:6: (lv_op_2_1= '*' | lv_op_2_2= '/' )
            	    {
            	    // InternalTestScriptDSL.g:980:6: (lv_op_2_1= '*' | lv_op_2_2= '/' )
            	    int alt13=2;
            	    int LA13_0 = input.LA(1);

            	    if ( (LA13_0==24) ) {
            	        alt13=1;
            	    }
            	    else if ( (LA13_0==25) ) {
            	        alt13=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 13, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt13) {
            	        case 1 :
            	            // InternalTestScriptDSL.g:981:7: lv_op_2_1= '*'
            	            {
            	            lv_op_2_1=(Token)match(input,24,FOLLOW_7); 

            	            							newLeafNode(lv_op_2_1, grammarAccess.getMulAndDivAccess().getOpAsteriskKeyword_1_1_0_0());
            	            						

            	            							if (current==null) {
            	            								current = createModelElement(grammarAccess.getMulAndDivRule());
            	            							}
            	            							setWithLastConsumed(current, "op", lv_op_2_1, null);
            	            						

            	            }
            	            break;
            	        case 2 :
            	            // InternalTestScriptDSL.g:992:7: lv_op_2_2= '/'
            	            {
            	            lv_op_2_2=(Token)match(input,25,FOLLOW_7); 

            	            							newLeafNode(lv_op_2_2, grammarAccess.getMulAndDivAccess().getOpSolidusKeyword_1_1_0_1());
            	            						

            	            							if (current==null) {
            	            								current = createModelElement(grammarAccess.getMulAndDivRule());
            	            							}
            	            							setWithLastConsumed(current, "op", lv_op_2_2, null);
            	            						

            	            }
            	            break;

            	    }


            	    }


            	    }

            	    // InternalTestScriptDSL.g:1005:4: ( (lv_right_3_0= ruleDot ) )
            	    // InternalTestScriptDSL.g:1006:5: (lv_right_3_0= ruleDot )
            	    {
            	    // InternalTestScriptDSL.g:1006:5: (lv_right_3_0= ruleDot )
            	    // InternalTestScriptDSL.g:1007:6: lv_right_3_0= ruleDot
            	    {

            	    						newCompositeNode(grammarAccess.getMulAndDivAccess().getRightDotParserRuleCall_1_2_0());
            	    					
            	    pushFollow(FOLLOW_13);
            	    lv_right_3_0=ruleDot();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getMulAndDivRule());
            	    						}
            	    						set(
            	    							current,
            	    							"right",
            	    							lv_right_3_0,
            	    							"org.TestScriptDSL.Dot");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMulAndDiv"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x000000000009D072L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x000000000009C070L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000020002L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000200002L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000C00002L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000003000002L});

}